<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
define('CPOBACKEND', true); 
if (isset($_GET['s'])) define('SETUP', true);
require_once('../_include/common.inc.php');

if (isset($_SESSION['SID_log_login_id'])) update_log_login($_SESSION['SID_log_login_id'], false);

$secIcons=array('', '&copysr;', '&copy;');
$secTexts=array(__('public rubric'), __('personalized rubric'), __('closed rubric'));
$username = __('Not logged in');
if (!empty($_SESSION['SID_log_login_id'])) {
    $username = formatUserName($_SESSION['SID_user']['id'], $_SESSION['SID_login'], $_SESSION['SID_user']['name']);
}
if (isset($_GET['s'])) {
    $username = sprintf(__('%s-Setup'), $CPO['product']);
    $cpoSystem['date_format'] = 'Y-m-d H:i';
}
?>
<html>
<head>
    <title><?php echo htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15') . ' &middot; ' . $cpoTitle ?></title>
    <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>" />
    <meta name="robots" content="noindex" />

    <?php if (!isset($_GET['s'])) { ?>
    <meta http-equiv="refresh" content="60; url=<?php echo htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15').'?'.time().'&amp;'.SID; ?>" />
    <meta http-equiv="pragma" content="no-cache" />
    <meta http-equiv="cache-control" content="no-cache" />
    <meta http-equiv="expires" content="0" />
    <?php } ?>
</head>
<body id="titleBody">
<div id="titleBar1">
    <a id="titleLogo" href="<?php echo $cpoLogoLink ?>" target="<?php echo $cpoLogoLinkTarget ?>"><img src="<?php print(htmlspecialchars(SKIN_URL.$cpoLogo, ENT_COMPAT, 'ISO-8859-15')); ?>" alt="<?php echo $cpoLogoAltTag ?>" ></a>

    <div style="position: absolute; bottom: 1px; left: 25px;">
        <?php 
        if (!empty($cpoSystem['project'])) echo htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15') . ' | '; 
        printf('<strong>%s</strong> | %s',
            htmlspecialchars($username, ENT_COMPAT, 'ISO-8859-15'),
            htmlspecialchars(date($cpoSystem['date_format'], time()), ENT_COMPAT, 'ISO-8859-15')
        );

        if (!empty($_SESSION['SID_log_login_id']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            $query = "SELECT COUNT(*) FROM ".CPO_LOG_LOGIN;
            DEBUG(2, 'Getting no. of logged in people<br />'.$query, __FILE__, __LINE__);
            $db->query($query);
            $db->next_record();

            printf(' | %s %s%d%s',
                ___('users online:'),
                $db->v('COUNT(*)')>0 ? '<a href="'.BASE_REL.'_admin/online_users.php" target="cpo_content">' : '',
                $db->v('COUNT(*)'),
                $db->v('COUNT(*)')>0 ? '</a>' : ''
            );
        }
        ?>
    </div>
</div>

<!-- dark background -->
<div id="titleBar2">
    <!-- needed to make sure the box stays this high. If replaced by a height: definition the IE will not display the box under the logo -->
        <?php
        if (!empty($_SESSION['SID_log_login_id'])) {
            // rubric chooser:
            print(___('Rubric:').' ');
            print('<select class="select" onChange="top.location.href = \''.BASE_REL.'_admin/index.php?navigation=\'+this.value;" style="min-width: 350px;">');
            print('<option value="0:0">'.__('[none]').'</option>');

            if (!empty($_SESSION['SID_user']['id'])) {

                // fetch all rubrics this user has access to
                $query = 'SELECT rubric_id '
                        .'FROM '.CPO_PERMISSION.' '
                        ."WHERE user_id='".addslashes($_SESSION['SID_user']['id'])."' ";
                DEBUG(1, $query, __FILE__, __LINE__);
                $db = new DB;
                $db->query($query);
                $rubricAccess = array();
                while ($db->next_record()) {
                    $rubricAccess[$db->v('rubric_id')] = true;
                }

                // fetch all rubrics to show the ones not in navigation
                $query = 'SELECT id, name, seclevel '
                        .'FROM '.CPO_RUBRIC.' '
                        .'ORDER BY name';
                DEBUG(1, $query, __FILE__, __LINE__);
                $db->query($query);
                $notInNavigation = array();
                while ($db->next_record()) {
                    $notInNavigation[$db->v('id')] = array(
                        'id'=>0,
                        'l'=>0,
                        'r'=>0,
                        'level'=>1,
                        'childs'=>0,
                        'caption'=>'',
                        'navigation'=>array(),
                        'rubric'=>array('id'=>$db->v('id'), 'name'=>$db->v('name'), 'seclevel'=>$db->v('seclevel'), )
                    );
                }

                $navigation = getNavigation();
                foreach ($navigation as $k=>$v) {

                    $path[$v['level']] = $v['caption'];

                    $secIcon = '';
                    $secText = '';

                    if (isset($v['rubric']['id']) && isset($notInNavigation[$v['rubric']['id']]['rubric']['seclevel']))  {
                        $secIcon = ' '.$secIcons[$notInNavigation[$v['rubric']['id']]['rubric']['seclevel']];
                        $secText = $secTexts[$notInNavigation[$v['rubric']['id']]['rubric']['seclevel']];
                    }

                    if (isset($v['rubric']['id']) && array_key_exists($v['rubric']['id'], $notInNavigation)) unset($notInNavigation[$v['rubric']['id']]);

                    if (!isset($v['rubric']['id']) || $v['rubric']['id']<=0) continue;
                    if (!isset($v['rubric']['id']) || !array_key_exists($v['rubric']['id'], $rubricAccess)) continue;

                    $entry = implode('/', array_slice($path, 0, $v['level']));
                    if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
                    if (strlen($entry)>90) $entry = '...'.substr($entry, -87);

                    printf('<option value="%d:%d" %s title="%s">%s</option>',
                        $v['id'],
                        $v['rubric']['id'],
                        (isset($_SESSION['SID_rubric_id']) && $v['rubric']['id']==$_SESSION['SID_rubric_id']) ? 'selected' : '',
                        $secText,
                        $entry.$secIcon
                    );
                }

                $_t = '<option value=""> </option>';
                foreach ($notInNavigation as $k=>$v) {
                    if (!array_key_exists($v['rubric']['id'], $rubricAccess)) continue;
                    print($_t);
                    $_t = '';

                    $path[$v['level']] = $v['rubric']['name'];

                    $secIcon = '';
                    $secText = '';

                    if (isset($notInNavigation[$v['rubric']['id']]['rubric']['seclevel']))  {
                        $secIcon = ' '.$secIcons[$notInNavigation[$v['rubric']['id']]['rubric']['seclevel']];
                        $secText = $secTexts[$notInNavigation[$v['rubric']['id']]['rubric']['seclevel']];
                    }

                    $entry = implode('/', array_slice($path, 0, $v['level']));
                    // no navigational element i
                    // if ($v['caption']!=$v['rubric']['name']) $entry .= ' ('.$v['rubric']['name'].')';
                    if (strlen($entry)>90) $entry = '...'.substr($entry, -87);

                    printf('<option value="%d:%d" %s title="%s">%s</option>',
                        $v['id'],
                        $v['rubric']['id'],
                        (isset($_SESSION['SID_rubric_id']) && $v['rubric']['id']==$_SESSION['SID_rubric_id']) ? 'selected' : '',
                        $secText,
                        $entry.$secIcon
                    );
                }
            }
            print('</select>&nbsp;&nbsp;');

            // display if rubric is personalized or closed
            if (isset($_SESSION['SID_rubric_secure']))  {
                switch ($_SESSION['SID_rubric_secure']) {
                case SECLEVEL_PERSONALIZED:
                    print('<img src="'.SKIN_URL.'lock1_personalized.gif" alt="'.__('personalized').'" title="'.__('personalized').'" style="vertical-align: text-bottom;" />');
                    break;
                case SECLEVEL_CLOSED:
                    print('<img src="'.SKIN_URL.'lock1_closed.gif" alt="'.__('closed').'" title="'.__('closed').'" style="vertical-align: text-bottom;" />');
                    break;
                }
            }
        // title icons by MR
        if(file_exists(CPO_BASEDIR.'_include/title_icons.inc.php')) include(CPO_BASEDIR.'_include/title_icons.inc.php');
        // title icons by MR
        }
        ?>
</div>
</body>
</html>
