<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: snippets.php 167 2007-03-05 20:49:59Z balu $ */
define('CPO', true);
define('CODEMIRROR', true);
require_once('../_include/checkaccess.inc.php');

// no access for non superusers/admins!
limitedAccess(ROLE_SUPERUSER);

require(CPO_BASEDIR.'_include/check.php');

$views = array('list'); // set default view

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) { 
    case 'pagetemplates_create':// {{{
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['pagetemplate'] = '';
        $views = array('create');
        break; // }}}
    case 'pagetemplates_copy': // {{{ 
        $query = "SELECT id, name, pagetemplate "
                ."FROM ".CPO_PAGETEMPLATES." "
                ."WHERE id='".addslashes($_GET['id'])."' ";
        $db = new DB;
        $db->query($query);
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['pagetemplate'] = '';
        while ($db->next_record()) {
            //$_REQUEST['id'] = $db->v('id');
            $_REQUEST['name'] = sprintf(__('Copy of %s'), $db->v('name'));
            $_REQUEST['rubric_id'] = $db->v('rubric_id');
            $_REQUEST['pagetemplate'] = $db->v('pagetemplate');
        }
        //array_unshift($actions, 'pagetemplates_savecopy');
        $views = array('copy');
        break; // }}}
    case 'pagetemplates_modify': // {{{
        $query = 'SELECT id, name, pagetemplate '
                .'FROM '.CPO_PAGETEMPLATES.' '
                ."WHERE id='".addslashes($_GET['id'])."' ";
        $db = new DB;
        $db->query($query);
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['pagetemplate'] = '';
        while ($db->next_record()) {
            $_REQUEST['id'] = $db->v('id');
            $_REQUEST['name'] = $db->v('name');
            $_REQUEST['pagetemplate'] = $db->v('pagetemplate');
        }
        $views = array('modify');
        break; // }}}
    case 'pagetemplates_save':  // {{{ pagetemplates_new, pagetemplates_savecopy
    case 'pagetemplates_new':
    case 'pagetemplates_savecopy':
        switch ($nextaction) {
        case 'pagetemplates_save':     $views = array('modify'); break;
        case 'pagetemplates_savecopy': $views = array('copy'); break;
        case 'pagetemplates_new':      $views = array('create'); break;
        }
        
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            switch ($nextaction) {
            case 'pagetemplates_save':     logaction('edit page-template',   'CSRF check failed'); break;
            case 'pagetemplates_new':      logaction('create page-template', 'CSRF check failed'); break;
            case 'pagetemplates_savecopy': logaction('copy page-template',   'CSRF check failed'); break;
            }
            break;
        }

        if (trim($_REQUEST['name'])=='') {
            $message[] = __('Please specify a name for this page-template.');
            break;
        }

        $query = 'REPLACE '.CPO_PAGETEMPLATES.' '
                .'(id, name, user_id, pagetemplate, saved) VALUES ('
                ."'".addslashes($_REQUEST['id'])."', "
                ."'".addslashes($_REQUEST['name'])."', "
                ."'".addslashes($_SESSION['SID_user']['id'])."', "
                ."'".addslashes($_REQUEST['pagetemplate'])."', "
                ."'".date('Y-m-d H:i:s')."' "
                .")";
        $db = new DB;
        $db->query($query);
        $db->query('SELECT last_insert_id()');
        $db->next_record();
        $_REQUEST['id'] = $db->v('last_insert_id()');

        $message[] = sprintf(___('The page-template %s was saved successfully.'),
            '<em>'.htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'
        );
        $views = array('list');
        switch ($nextaction) {
        case 'pagetemplates_save':     logaction('edit page-template',   $_REQUEST['name']); break;
        case 'pagetemplates_new':      logaction('create page-template', $_REQUEST['name']); break;
        case 'pagetemplates_savecopy': logaction('copy page-template',   $_REQUEST['name']); break;
        }
        break; // }}}
    case 'pagetemplates_delete': // {{{
        $db = new DB;
        $db->query('SELECT name '
            .'FROM '.CPO_PAGETEMPLATES.' '
            .'WHERE id='.(int)$_GET['id']
        );
        $db->next_record();
        $name = $db->v('name');
        $views = array('reallydelete');
        break; // }}}
    case 'pagetemplates_delete_really':  // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete page-template', 'CSRF check failed.');

            $db = new DB;
            $db->query('SELECT name '
                .'FROM '.CPO_PAGETEMPLATES.' '
                .'WHERE id='.(int)$_REQUEST['id']
            );
            $db->next_record();
            $name = $db->v('name');
            $views = array('reallydelete');
            break;
        }

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The page-template %s was not deleted.'),
                '<em>'.htmlspecialchars($_POST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
            break;
        }

        $query = 'DELETE FROM '.CPO_PAGETEMPLATES." "
                .'WHERE id='.(int)$_REQUEST['id'];
        $db = new DB;
        $db->query($query);

        $message[] = sprintf(___('The page-template %s was deleted successfully.'),
            sprintf('<em>%s</em> [%d]', 
                htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), 
                htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')
            )
        );
        $views = array('list');
        logaction('delete page-template', $_REQUEST['name']);
        break; // }}}
    }
}

require(CPO_BASEDIR.'_include/header.php');
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'modify': // {{{ create, copy
    case 'create':
    case 'copy':
        switch ($nextview) {
        case 'create': 
            printPageHeader(
                __('Create page-template'),
                __('In this view you can create a new page-template.'),
                '' // helpme
            );
            break;
        case 'modify':
            printPageHeader(
                __('Edit page-template'),
                sprintf(__('In this view you can edit the page-template %s.'), 
                    sprintf('<em>%s</em> [%d]', 
                        htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), 
                        htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')
                    )),
                '' // helpme
            );
            break;
        case 'copy':
            printPageHeader(
                __('Copy page-template'),
                sprintf(__('In this view you create a copy of page-template %s.'), 
                    sprintf('<em>%s</em> [%d]', 
                        htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), 
                        htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')
                    )),
                '' // helpme
            );
        }
        include(CPO_BASEDIR.'_include/message.php');

        printf('<form method="post" action="%s">', htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'));
        printf('<input type="hidden" name="id" value="%d" />', htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')); 
        switch ($nextview) {
        case 'create':
            $antiCSRF->printInput('pagetemplates_new');
            break;
        case 'modify':
            $antiCSRF->printInput('pagetemplates_save');
            break;
        case 'copy':
            $antiCSRF->printInput('pagetemplates_savecopy');
        }
        print('<table class="colored" style="width: 100%"><thead><tr>');
        printf('<th colspan="2"><span>%s</span></th>', ___('Page-template'));
        print('</tr></thead><tbody>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', ___('Name:'));
        printf('<input type="text" class="text inputwidth" name="name" value="%s" />', 
            htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15')
        );
        print(help('')); // helpme
        print('</td></tr>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', ___('Content:'));
        printf('<textarea class="text inputwidth" id="pagetemplate" name="pagetemplate" rows="40">%s</textarea>', 
            htmlspecialchars($_REQUEST['pagetemplate'], ENT_COMPAT, 'ISO-8859-15')
        );
        //print(help('')); // helpme
        print('</td></tr>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', '&nbsp;');
        printf('<input type="submit" class="button" value="%s" />', 
            ___('save')
        );
        print('</td></tr>');

        print('</tbody></table>');
        print('</form>');
        
		// Mod_editor *******************************************************************************************
		if (array_key_exists('Editor',$activeModules)) include(CPO_BASEDIR.'mod_editor/CPO/'.basename(__FILE__));
		// Mod_editor *******************************************************************************************
		
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'list': // {{{
        printPageHeader(
            __('Work on page-templates'),
            __('In this view you can work on all available page-templates.'),
            '' // helpme
        );

        $db = new DB;
        $db->query('SELECT '
            .'pagetemplate, '
            .'user_id, '
            .CPO_PAGETEMPLATES.'.id, '
            .CPO_PAGETEMPLATES.'.name as pagetemplate_name, '
            .CPO_PAGETEMPLATES.'.saved, '
            .'user, '
            .CPO_USER.'.name as user_name, '
            .CPO_USER.'.name as user_name '

            .'FROM '.CPO_PAGETEMPLATES.', '.CPO_USER.' '
            .'WHERE user_id='.CPO_USER.'.id '
            .'ORDER BY '.CPO_PAGETEMPLATES.'.name'
        );
            
        if ($db->num_rows()<=0) {
            $message[] =  __('No page-templates found.').' '
                .sprintf(___('You can %screate a new page-template%s.'),
                    '<a href="'.BASE_REL.'_admin/pagetemplates.php?action=pagetemplates_create">',
                    '</a>');

            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break; 
        } 

        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="ruler" style="width: 100%">');
        print('<thead><tr>');
        print('<th style="width: 50%;"><span>'.___('Name').help('').'</span></th>'); // helpme
        print('<th style="width:  5%;"><span>'.___('Manage').help('').'</span></th>'); // helpme
        print('<th style="width: 30%;"><span>'.___('Author').help('').'</span></th>'); // helpme
        print('<th style="width: 15%;"><span>'.___('Last modified').help('').'</span></th>'); // helpme
        print('</tr></thead><tbody>');

        while($db->next_record()) {
            // Name
            printf('<td>%s</td>', $db->v('pagetemplate_name'));

            // Manage
            print('<td>');
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'pagetemplates_modify&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_edit.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('edit page-template')
            );
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'pagetemplates_copy&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_copy.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('copy page-template')
            );
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'pagetemplates_delete&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15').'&amp;name='.htmlspecialchars($db->v('pagetemplate_name'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_del.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('delete page-template')
            );
            echo '</td>';

            // Author
            printf('<td>%s</td>', formatUserName($db->v('user_id'), $db->v('user'), $db->v('user_name')));

            // Last modified
            echo '<td>';
            print(date($cpoSystem['date_format'], strtotime($db->v('saved'))));
            echo '</td>';

            echo '</tr>';
        }

        echo '</table>';
        include(CPO_BASEDIR.'_include/footer.php');

        break; // }}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Delete page-template'),
            sprintf(___('You are going to delete the page-template %s.'),
                '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            '' // helpme
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the page-template %s?'),
            '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('pagetemplates_delete_really');
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="name" value="'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    }
}