<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Modification "ShowArticle"					                 |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 1.1 / April 2023 ==

*/

define('CPO', true);

require_once('../_include/checkaccess.inc.php');


// the template should be canged to fit your needs
$showTemplate = '
### content ###
<div style="border: border-radius: 6px; box-shadow: 0px 1.6px 3.6px rgba(0,0,0,0.13), 0px 0px 2.9px rgba(0,0,0,0.11); padding: 1rem;">
<p>Auswahl der Seitenart:</p>
<p>### selector ###</p>
<p style="font-size:0.5rem;"><img src="../_skin/conpresso/sym_info.gif" style="float: left; margin-right: 3px;" />Diese Ansicht ist nur fr die redaktionelle Arbeit gedacht und kann von Besuchern nicht betrachtet werden!</p>
</div>
';


ob_start();

$pagetype = (!isset($_GET['pagetype'])) ? 'index' : $_GET['pagetype'];
require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/secure.php');

$showRubricSettings = $cpoRubrics[$_SESSION['SID_rubric_source_rubric_id']]['settings'];

$query  =  "SELECT 
			rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify 
			FROM ".CPO_NEWS." 
			WHERE 
			nr=".$_REQUEST['nr']."
			";
$db = new DB;
$db->query($query);

$GLOBALS['lastUpdated'] = 0;
while($db->next_record()) {

    $db_template      = $db->v('templates_id');
    $db_nr            = $db->v('nr');
    $db_idx           = $db->v('idx');
    $db_email         = $db->v('email');
    $db_autor         = $db->v('autor');
    $db_changer       = $db->v('changer');
    $db_pub_datum     = $db->v('pub_datum');
    $db_verfallsdatum = $db->v('verfallsdatum');
    $db_commentary    = $db->v('commentary');
    $db_titel         = $db->v('titel');
    $db_initial       = $db->v('initial');
    $db_freigabe      = $db->v('freigabe');
    $db_rubric_id     = $db->v('rubric_id');
    $db_last_modify   = $db->v('last_modify');
    if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
        $GLOBALS['lastUpdated'] = strtotime($db_last_modify);
    }
    require(CPO_BASEDIR.'_include/select_template.php');

}

$showContent = ob_get_clean();


$showSelector = 
     (($pagetype != "index")?'<a href="show_article.php?rubric='.$_GET['rubric'].'&nr='.$_GET['nr'].'&pagetype=index">Rubrikseite</a>':"Rubrikseite")." | "
    .(($pagetype != "detail")?'<a href="show_article.php?rubric='.$_GET['rubric'].'&nr='.$_GET['nr'].'&pagetype=detail">Artikelseite</a>':"Artikelseite")." | "
    .(($pagetype != "php")?'<a href="show_article.php?rubric='.$_GET['rubric'].'&nr='.$_GET['nr'].'&pagetype=php">PHP/JS</a>':"PHP/JS");

$showTemplate = str_replace(array('### content ###', '### selector ###'), array($showContent, $showSelector), $showTemplate);


// header and footer mechanism
if ($pagetype == 'php') { // only content for php
    echo $showTemplate;
    exit;
}

if ($showRubricSettings['pagetemplate_'.$pagetype]==0) { // header and footer mechanism only for index/detail
    include(CPO_BASEDIR.$_SESSION['SID_rubric_directory'].'/loadheaders.php');
    echo $showTemplate;
    include(CPO_BASEDIR.$_SESSION['SID_rubric_directory'].'/loadfooters.php');
    exit;
}

// fetch pagetemplate from database and build page
$pagetemplate = $showRubricSettings['pagetemplate_'.$pagetype];

$db = new DB;
$db->query('SELECT pagetemplate FROM '.CPO_PAGETEMPLATES.' '
    .'WHERE id='.(int)$pagetemplate.' '
);
$db->next_record();
$pageTemplate = $db->v('pagetemplate');
$pageTagsPreg = '/<!--\s*page\s*:\s*articles\s*(?!id=)[^>]\s*-->/isU'; // nur der Artikelplatzhalter der aktuellen Rubrik, also OHNE id
$pageTemplate = preg_replace ($pageTagsPreg, $showTemplate, $pageTemplate);
require CPO_BASEDIR.'_include/buildpage.inc.php';

