<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');

// no access for non superusers/admins!
limitedAccess(ROLE_SUPERUSER);

require(CPO_BASEDIR.'_include/var_category.php'); // FIXME needed?
require(CPO_BASEDIR.'_include/check.php');

$views = array('list'); // set default view

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) { 
    case 'snippets_create':// {{{
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['rubric_id'] = -1;
        $_REQUEST['snippet'] = '';
        $views = array('create');
        break; // }}}
    case 'snippets_copy': // {{{ // FIXME
        $query = "SELECT id, name, rubric_id, snippet "
                ."FROM ".CPO_SNIPPET." "
                ."WHERE id='".addslashes($_GET['id'])."' ";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['rubric_id'] = 0;
        $_REQUEST['snippet'] = '';
        while ($db->next_record()) {
            //$_REQUEST['id'] = $db->v('id');
            $_REQUEST['name'] = sprintf(__('Copy of %s'), $db->v('name'));
            $_REQUEST['rubric_id'] = $db->v('rubric_id');
            $_REQUEST['snippet'] = $db->v('snippet');
        }
        //array_unshift($actions, 'snippets_savecopy');
        $views = array('copy');
        break; // }}}
    case 'snippets_modify': // {{{
        $query = "SELECT id, name, rubric_id, snippet "
                ."FROM ".CPO_SNIPPET." "
                ."WHERE id='".addslashes($_GET['id'])."' ";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
        $_REQUEST['id'] = 0;
        $_REQUEST['name'] = '';
        $_REQUEST['rubric_id'] = 0;
        $_REQUEST['snippet'] = '';
        while ($db->next_record()) {
            $_REQUEST['id'] = $db->v('id');
            $_REQUEST['name'] = $db->v('name');
            $_REQUEST['rubric_id'] = $db->v('rubric_id');
            $_REQUEST['snippet'] = $db->v('snippet');
        }
        $views = array('modify');
        break; // }}}
    case 'snippets_save':  // {{{ snippets_new, snippets_savecopy
    case 'snippets_new':
    case 'snippets_savecopy':
        switch ($nextaction) {
        case 'snippets_save':     $views = array('modify'); break;
        case 'snippets_savecopy': $views = array('copy'); break;
        case 'snippets_new':      $views = array('create'); break;
        }
        
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            switch ($nextaction) {
            case 'snippets_save':     logaction('edit snippet',   'CSRF check failed.'); break;
            case 'snippets_new':      logaction('create snippet', 'CSRF check failed.'); break;
            case 'snippets_savecopy': logaction('copy snipped',   'CSRF check failed.'); break;
            }            
            break;
        }

        if (trim($_REQUEST['name'])=='') {
            $message[] = __('Please specify a name for this snippet.');
            break;
        }

        $query = "REPLACE ".CPO_SNIPPET." "
                ."(id, name, rubric_id, user_id, snippet, lastmodify) VALUES ("
                ."'".addslashes($_REQUEST['id'])."', "
                ."'".addslashes($_REQUEST['name'])."', "
                ."'".addslashes($_REQUEST['rubric_id'])."', "
                ."'".addslashes($_SESSION['SID_user']['id'])."', "
                ."'".addslashes($_REQUEST['snippet'])."', "
                ."'".addslashes(date('Y-m-d H:i:s'))."' "
                .")";
        DEBUG(1, 'storing settings in database.<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
        $db->query('SELECT last_insert_id()');
        $db->next_record();
        $_REQUEST['id'] = $db->v('last_insert_id()');

        $message[] = sprintf(___('The snippet %s was saved successfully.'),
                '<em>'.htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
        $views = array('list');
        switch ($nextaction) {
        case 'snippets_save':     logaction('edit snippet',   $_REQUEST['name']); break;
        case 'snippets_new':      logaction('create snippet', $_REQUEST['name']); break;
        case 'snippets_savecopy': logaction('copy snipped',   $_REQUEST['name']); break;
        }
        break; // }}}
    case 'snippets_delete': // {{{
        $db = new DB;
        $db->query("SELECT name "
                  ."FROM ".CPO_SNIPPET." "
                  ."WHERE id='".addslashes($_GET['id'])."'");
        $db->next_record();
        $name = $db->v('name');
        $views = array('reallydelete');
        break; // }}}
    case 'snippets_delete_really':  // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete snippet', 'CSRF check failed.');
            $db = new DB;
            $db->query("SELECT name "
                      ."FROM ".CPO_SNIPPET." "
                      ."WHERE id='".addslashes($_REQUEST['id'])."'");
            $db->next_record();
            $name = $db->v('name');
            $views = array('reallydelete');
            break;
        }

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The snippet %s was not deleted.'),
                '<em>'.htmlspecialchars($_POST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
            break;
        }

        $query = "DELETE FROM ".CPO_SNIPPET." "
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);

        $message[] = sprintf(___('The snippet %s was deleted successfully.'),
            sprintf('<em>%s</em> [%d]', htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')));
        $views = array('list');
        logaction('delete snippet', $_REQUEST['name']);
        break; // }}}
    }
}

require(CPO_BASEDIR.'_include/header.php');
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'modify': // {{{ create, copy
    case 'create':
    case 'copy':
        switch ($nextview) {
        case 'create': 
            printPageHeader(
                __('Create snippet'),
                __('In this view you can create a new snippet.'),
                'snippets-createsnippet.html#snippets-createsnippet'
            );
            break;
        case 'modify':
            printPageHeader(
                __('Edit snippet'),
                sprintf(__('In this view you can edit the snippet %s.'), sprintf('<em>%s</em> [%d]', 
                    htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), 
                    htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')
                )),
                'snippets-workonsnippets.html#snippets-workonsnippets-workonsnippet'
            );
            break;
        case 'copy':
            printPageHeader(
                __('Copy snippet'),
                sprintf(__('In this view you create a copied snippet %s.'), sprintf('<em>%s</em> [%d]', 
                    htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'), 
                    htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')
                )),
                'snippets-copysnippet.html#snippets-copysnippet'
            );
        }
        include(CPO_BASEDIR.'_include/message.php');

        printf('<form method="post" action="%s">', htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'));
        printf('<input type="hidden" name="id" value="%d" />', htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15')); 
        switch ($nextview) {
        case 'create': 
            $antiCSRF->printInput('snippets_new');
            break;
        case 'modify':
            $antiCSRF->printInput('snippets_save');
            break;
        case 'copy':
            $antiCSRF->printInput('snippets_savecopy');
        }
        print('<table class="colored" style="width: 100%"><thead><tr>');
        printf('<th colspan="2"><span>%s</span></th>', ___('Snippet'));
        print('</tr></thead><tbody>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', ___('Name:'));
        printf('<input type="text" class="text inputwidth" name="name" value="%s" />', 
            htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15')
        );
        print(help('snippets-createsnippet.html#snippets-createsnippet-name'));
        print('</td></tr>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', ___('Content:'));
        printf('<textarea class="text inputwidth" name="snippet" rows="10">%s</textarea>', 
            htmlspecialchars($_REQUEST['snippet'], ENT_COMPAT, 'ISO-8859-15')
        );
        print(help('snippets-createsnippet.html#snippets-createsnippet-content'));
        print('</td></tr>');

        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', ___('Available in:'));
        printf('<input type="radio" name="rubric_id" id="rubric_id-1" value="%d" %s /><label for="rubric_id-1">%s</label>',
            -1,
            $_REQUEST['rubric_id']==-1 ? ' checked' : '',
            __('all rubrics'));

        if ($_REQUEST['rubric_id']>0 && $_SESSION['SID_rubric_id']!=$_REQUEST['rubric_id']) {
            $query = "SELECT name "
                    ."FROM ".CPO_RUBRIC." "
                    ."WHERE id='".addslashes($_REQUEST['rubric_id'])."'";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db2 = new DB;
            $db2->query($query);
            $db2->next_record();
            printf('<br /><input type="radio" name="rubric_id" id="rubric_id_'.(int)$_REQUEST['rubric_id'].'" value="%d" %s /><label for="rubric_id_'.(int)$_REQUEST['rubric_id'].'">%s</label>',
                htmlspecialchars($_REQUEST['rubric_id'], ENT_COMPAT, 'ISO-8859-15'),
                'checked',
                sprintf(___('in rubric %s'), '<em>'.htmlspecialchars($db2->v('name'), ENT_COMPAT, 'ISO-8859-15').'</em>')
            );
        }

        if ($_SESSION['SID_rubric_id']!='') {
            printf('<br /><input type="radio" name="rubric_id" id="rubric_id_'.(int)$_SESSION['SID_rubric_id'].'" value="%d" %s /><label for="rubric_id_'.(int)$_SESSION['SID_rubric_id'].'">%s</label>',
                htmlspecialchars($_SESSION['SID_rubric_id'], ENT_COMPAT, 'ISO-8859-15'),
                $_SESSION['SID_rubric_id']==$_REQUEST['rubric_id'] ? ' checked' : '',
                sprintf(___('in rubric %s'), '<em>'.htmlspecialchars($_SESSION['SID_rubric_name'], ENT_COMPAT, 'ISO-8859-15')).'</em>'
            );
        } 
        print(help('snippets-createsnippet.html#snippets-createsnippet-availablein'));
        print('</td></tr>');


        printf('<tr><td class="leftrow">%s</td><td class="rightrow">', '&nbsp;');
        printf('<input type="submit" class="button" value="%s" />', 
            ___('save')
        );
        print('</td></tr>');

        print('</tbody></table>');
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'list': // {{{
        printPageHeader(
            __('Work on snippets'),
            __('In this view you can work on all available snippets.'),
            'snippets-workonsnippets.html#snippets-workonsnippets'
        );

        $query = "SELECT "
                ."snippet, "
                ."rubric_id, "
                ."user_id, "
                .CPO_SNIPPET.".id, "
                .CPO_SNIPPET.".name as snippet_name, "
                .CPO_SNIPPET.".changer, "
                .CPO_SNIPPET.".lastmodify, "
                ."user, "
                .CPO_USER.".name as user_name, "
                .CPO_USER.".name as user_name "

                ."FROM ".CPO_SNIPPET.", ".CPO_USER." "
                ."WHERE user_id=".CPO_USER.".id "
                ."ORDER BY ".CPO_SNIPPET.".name";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
            
        if ($db->num_rows()<=0) {
            $message[] =  __('No snippets found.').' '
                .sprintf(___('You can %screate a new snippet%s.'),
                    '<a href="'.BASE_REL.'_admin/snippets.php?action=snippets_create">',
                    '</a>');

            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break; 
        } 

        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="ruler" style="width: 100%">');
        print('<thead><tr>');
        print('<th style="width: 50%;"><span>'.___('Name').help('snippets-workonsnippets.html#snippets-workonsnippets-name').'</span></th>');
        print('<th style="width:  5%;"><span>'.___('Manage').help('snippets-workonsnippets.html#snippets-workonsnippets-edit').'</span></th>');
        print('<th style="width: 30%;"><span>'.___('Author').help('snippets-workonsnippets.html#snippets-workonsnippets-author').'</span></th>');
        print('<th style="width: 15%;"><span>'.___('Last modified').help('snippets-workonsnippets.html#snippets-workonsnippets-lastedit').'</span></th>');
        print('</tr></thead><tbody>');

        while($db->next_record()) {

            // Name
            printf('<td>%s</td>', $db->v('snippet_name'));

            // Manage
            print('<td>');
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'snippets_modify&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_edit.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('edit snippet')
            );
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'snippets_copy&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_copy.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('copy snippet')
            );
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'snippets_delete&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15').'&amp;name='.htmlspecialchars($db->v('snippet_name'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_del.gif', ENT_COMPAT, 'ISO-8859-15'), 
                ___('delete snippet')
            );
            echo '</td>';

            // Author
            printf('<td>%s</td>', formatUserName($db->v('user_id'), $db->v('user'), $db->v('user_name')));

            // Last modified
            echo '<td>';
            print(date($cpoSystem['date_format'], strtotime($db->v('lastmodify'))));
            echo '</td>';

            echo '</tr>';
        }

        echo '</table>';
        include(CPO_BASEDIR.'_include/footer.php');

        break; // }}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Delete Snippet'),
            sprintf(___('You are going to delete the snippet %s.'),
                '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'snippets-deletesnippet.html#snippets-deletesnippet'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the snippet %s?'),
            '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('snippets_delete_really');
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="name" value="'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    }
}