<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

// no access for non admins!
limitedAccess(ROLE_ADMIN);

$zugang = 0;

require(CPO_BASEDIR.'_include/check.php');
require(CPO_BASEDIR.'_include/header.php');

// get navigation to set startup
doActions($hdlr_navigation);
foreach($navigation AS $nKey=>$nVal)  initVar($cpoSystemDefaults['startup'][$nKey], NULL);

if (isset($_POST['go'])) { // FIXME switch to MVC
    // fetch $_POST values into the global space and overwrite the settings 
    // loaded in _include/common.inc.php
    $cpoSystem = array();
    foreach ($cpoSystemDefaults as $k=>$v) {
        initVar($_POST['cpoSystemNew'][$k],NULL);
        // if the default value is of type bool, cast them :)
        if (is_bool($cpoSystemDefaults[$k])) {
            $cpoSystem[$k] = (bool) $_POST['cpoSystemNew'][$k];
        }
        else $cpoSystem[$k] = $_POST['cpoSystemNew'][$k];
    }

    // targets can be divided using blanks, '.', ';' or ','
    // store them with blanks as divider
    $cpoSystem['targets'] = preg_replace('/(\.|;|,|\s)+/', ' ', $cpoSystem['targets']);

    $c_datum = date ('Y-m-d H:i:s');
    $query = sprintf(
             'REPLACE INTO '.CPO_OPTION.' (type, options, id) '
            ."VALUES ('system', '%s', '1')", // FIXME really use id 1 here?
            addslashes(serialize($cpoSystem))
    );
    $db = new DB;
    $db->query($query); 

    initVar($cpoSystem['released'],NULL);

    // update database if no release is necessary
    if (!$cpoSystem['released']) {
        $db = new DB;
        $query = 'UPDATE '.CPO_NEWS.' '
                .'SET freigabe = '.STATE_RELEASED.' '
                .'WHERE freigabe='.STATE_WAITING;
        $db->query($query); 

        $query = 'UPDATE '.CPO_NEWS.' '
                .'SET freigabe = '.STATE_BLOCKED.' '
                .'WHERE freigabe='.STATE_REJECTED.' ';
        $db->query($query); 
    }

    logaction('edit system settings', '');

    $message[] = ___('System settings were updated!');
}

printPageHeader(
    __('Edit system settings'),
    __('In this view you can edit the license and system settings.'),
    'system-systemsettings.html#system-systemsettings'
);
include(CPO_BASEDIR.'_include/message.php');
?>

    <form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
    <input type="hidden" name="go" value="1">
    <input type="hidden" name="cpoSystemNew[installed]" value="<?php echo htmlspecialchars($cpoSystem['installed'], ENT_COMPAT, 'ISO-8859-15'); ?>" />
    <table class="colored" style="width: 100%"><thead>
        <tr>
            <th colspan="2"><span><?php echo ___('License'); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('License type:'); ?></div></td>
            <td class="rightrow">
                <?php
                switch (license($cpoSystem['lkey'])) {
                case 1:
                    echo ___('commercial license');
                    break;
                case 2:
                    echo ___('non commercial license');
                    break;
                case 3: 
                    echo ___('test license');
                    break;
                case 4:
                    echo ___('expired test license');
                    break;
                case 5:
                    echo ___('school license');
                    break;
                case false:
                    echo ___('unregistered version');
                    break;
                default:
                    echo ___('unknown license type');
                }
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Licensee:'); ?></td>
            <td class="rightrow">
                <input type="text" class="text inputwidth" name="cpoSystemNew[owner]" value="<?php print(htmlspecialchars($cpoSystem['owner'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-license-licensee'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('License key:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[lkey]" value="<?php print(htmlspecialchars($cpoSystem['lkey'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-license-licensekey'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Used product version:'); ?></td>
            <td>
                <?php print(htmlspecialchars($CPO['version'], ENT_COMPAT, 'ISO-8859-15')); ?>
                <?php echo help('system-systemsettings.html#system-systemsettings-license-productversion'); ?>
            </td>
        </tr><tr>
            <td>&nbsp;</td>
            <td>
                <input type="submit" class="button" name="lizence" value="<?php echo ___('save'); ?>">
            </td>
        </tr>
    </tbody></table>

    <table class="colored" style="width: 100%;"><thead>
        <tr>
            <th colspan="2"><span><?php print(___('Project')); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('Name of project:'); ?></td>
            <td class="rightrow">
                <input type="text" class="text inputwidth" name="cpoSystemNew[project]" value="<?php print(htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-projectname'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Release:'); ?></td>
            <td>
                <select name="cpoSystemNew[release]" size="1">
                    <option value="1" <?php if ($cpoSystem['release']) echo "selected"; ?>><?php echo ___('release necessary'); ?></option>
                    <option value="0" <?php if (!$cpoSystem['release']) echo "selected"; ?>><?php echo ___('NO release necessary'); ?></option>
                </select>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-release'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Sender of system e-mail:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[system_email]" value="<?php print(htmlspecialchars($cpoSystem['system_email'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-systemmail'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Sender of administrative e-mails:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[admin_email]" value="<?php print(htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-adminmail'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Timeout:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[timeout]" value="<?php print(htmlspecialchars($cpoSystem['timeout'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="5">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-timeout'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Max. size of images:'); ?></td>
            <td>
                <input type="text" class="text" name="cpoSystemNew[max_image]" value="<?php print(htmlspecialchars($cpoSystem['max_image'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="20"><?php 
                printf(' '.___('Bytes (max. size allowed by server: %sbyte)'), ini_get('upload_max_filesize')); ?>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-maxsizeimages'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Max. size of files:'); ?></td>
            <td>
                <input type="text" class="text" name="cpoSystemNew[max_file]" value="<?php print(htmlspecialchars($cpoSystem['max_file'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="20"><?php 
                printf(' '.___('Bytes (max. size allowed by server: %sbyte)'), ini_get('upload_max_filesize')); ?>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-maxsizefiles'); ?>
            </td>
        </tr><tr>
            <td><?php print(___('Language:')); ?></td>
            <td>
                <select name="cpoSystemNew[language]" size="1">
                    <?php
                    $d = $translator->findTranslations();

                    foreach ($d as $v) {
                        echo '<option value="'.$v.'"';
                        if ($cpoSystem['language']==$v) echo " selected";
                        echo ">".htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15')."</option>\n";
                    }
                    ?>
                </select>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-systemlanguage'); ?>
            </td>
        </tr><tr>
            <td><?php print(___('Skin:')); ?></td>
            <td>
                <select name="cpoSystemNew[skin]" size="1">
                    <?php
                    $skindirs = array();
                    if ($handle = opendir(CPO_BASEDIR.'_skin/')) {
                        while (($file = readdir($handle)) !== false) {
                            if (!is_dir(CPO_BASEDIR.'_skin/'.$file) 
                                || !is_readable(CPO_BASEDIR.'_skin/'.$file) 
                                || !file_exists(CPO_BASEDIR.'_skin/'.$file.'/common-skin.php')) continue;
                            $skindirs[] = $file;
                        }
                        closedir($handle);
                    }
                    sort($skindirs);
                    foreach ($skindirs as $v) {
                        printf('<option value="%1$s" %2$s>%1$s</option>', 
                            htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15'),
                            $cpoSystem['skin'] == $v ? 'selected' : ''
                        );
                    }
                    ?>
                </select>
                <?php
                echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                echo ___('Please make sure to reload the page after changing the skin!');

                echo help('system-systemsettings.html#system-systemsettings-skin'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Base URL:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[base_url]" value="<?php print(htmlspecialchars($cpoSystem['base_url'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php
                echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                echo sprintf(___('In case of an empty field or \'auto\' %s will use: '), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'<em>'.htmlspecialchars($auto_base_url, ENT_COMPAT, 'ISO-8859-15').'</em><br />';
                echo ___('Please make sure that this value is correct before using the autodetected value!');

                echo help('system-systemsettings.html#system-systemsettings-project-baseurl'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Send passwords:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" name="cpoSystemNew[send_pw]" id="send_pw" value="1" <?php if ($cpoSystem['send_pw']) echo "checked"; ?>><label for="send_pw"> <?php print(___('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-passwordbymail'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Online help:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" id="help" name="cpoSystemNew[help]" id="help" value="1" <?php if ($cpoSystem['help']) echo "checked"; ?>><label for="help"> <?php print(__('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-onlinemanual'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('IP check:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" name="cpoSystemNew[ipcheck]" id="ipcheck" value="1" <?php if ($cpoSystem['ipcheck']) echo "checked"; ?>><label for="ipcheck"> <?php print(___('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-ipcheck'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Store session in database:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" name="cpoSystemNew[sessionsInDB]" id="sessionsInDB" value="1" <?php if ($cpoSystem['sessionsInDB']) echo "checked"; ?>><label for="sessionsInDB"> <?php print(___('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-sessionsindb'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Page statistics:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" name="cpoSystemNew[statistics]" id="statistics" value="1" <?php if ($cpoSystem['statistics']) echo "checked"; ?>><label for="statistics"> <?php print(___('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-accesscounter'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Use PATH_INFO:'); ?></td>
            <td>
                <input class="checkbox" type="checkbox" name="cpoSystemNew[PATH_INFO]" id="PATH_INFO" value="1" <?php if ($cpoSystem['PATH_INFO']) echo "checked"; ?>><label for="PATH_INFO"> <?php print(___('enable')); ?></label>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-seolinks'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Frame targets:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[targets]" value="<?php print(htmlspecialchars($cpoSystem['targets'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="35" maxlength="255">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-targetframes'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Pagination position in backend:'); ?></td>
            <td>
                <select name="cpoSystemNew[pagination]" size="1">
                <?php
                    printf('<option value="%s" %s>%s</option>',
                        'both',
                        $cpoSystem['pagination']=='both' ? 'selected' : '',
                        __('top and bottom')
                    );
                    printf('<option value="%s" %s>%s</option>',
                        'top',
                        $cpoSystem['pagination']=='top' ? 'selected' : '',
                        __('only top')
                    );
                    printf('<option value="%s" %s>%s</option>',
                        'bottom',
                        $cpoSystem['pagination']=='bottom' ? 'selected' : '',
                        __('only bottom')
                    );
                print('</select>');
                ?>
                <?php echo help('system-systemsettings.html#system-systemsettings-project-nooffiles'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('No. of files/images in list view:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[noOfFiles]" value="<?php print(htmlspecialchars($cpoSystem['noOfFiles'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="5">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-nooffiles'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('No. of articles in list view:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[noOfArticles]" value="<?php print(htmlspecialchars($cpoSystem['noOfArticles'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="5">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-noofarticles'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('No. of uploads:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[noOfUploadFiles]" value="<?php print(htmlspecialchars($cpoSystem['noOfUploadFiles'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="20" maxlength="5">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-noofuploads'); ?>
            </td>
        </tr><tr>
            <td><?php echo ___('System homepage:'); ?></td>
            <td>
                <select name="cpoSystemNew[homepage]" size="1">
                <?php
// FIXME NEW NAVI
                printf('<option value="%s" %s>%s</option>',
                    htmlspecialchars('_admin/index.php', ENT_COMPAT, 'ISO-8859-15'),
                    '_admin/index.php' == $cpoSystem['homepage'] ? 'selected' : '',
                    ___('Backend login')
                );

                $query = 'SELECT name, directory  '
                        .'FROM '.CPO_RUBRIC.' '
                        .'ORDER BY name';
                $db = new DB;
                $db->query($query);

                while($db->next_record()) {
                    $url = $db->v('directory').'/index.php';
                    if (strtolower($db->v('directory'))!=strtolower($db->v('name'))) {
                        $url .= ('?rubric='.urlencode($db->v('name')));
                    }
                    printf('<option value="%s" %s>%s</option>',
                        htmlspecialchars($url, ENT_COMPAT, 'ISO-8859-15'),
                        $url == $cpoSystem['homepage'] ? 'selected' : '',
                        $db->v('name')
                    );
                }
                print('</select>');
                echo help('system-systemsettings.html#system-systemsettings-project-systemstartpage'); 
                ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Date format:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[date_format]" value="<?php print(htmlspecialchars($cpoSystem['date_format'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="36" maxlength="36">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-dateformat'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Default sorting method:'); ?></td>
            <td class="rightrow">
                <?php
$fields = array(
    'titel ASC'          => 'Title ascending', 
    'titel DESC'         => 'Title descending', 
    'datum ASC'          => 'Date ascending',
    'datum DESC'         => 'Date descending',
    'verfallsdatum ASC'  => 'Expiration date ascending',
    'verfallsdatum DESC' => 'Expiration date descending',
    'pub_datum ASC'      => 'Publication date ascending',
    'pub_datum DESC'     => 'Publication date descending',
    'idx ASC'            => 'Index ascending',
    'idx DESC'           => 'Index descending',
    'sort_id DESC'       => 'Manual',
);

    echo '<select name="cpoSystemNew[sorting]">';
    foreach ($fields as $field => $caption) {
        echo '<option value="' . $field . '" ' . 
            ($cpoSystem['sorting']==$field ? 'selected' : '') . 
            '>';
        echo ___($caption) . '</option>';
    }
    echo '</select>';
     ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Default article-template:'); ?></td>
            <td>
                <?php
                $query = "SELECT id, name FROM ".CPO_TEMPLATES." "
                        ."ORDER BY name";
                $db->query($query);

                echo '<select name="cpoSystemNew[standard_template]" size="1">';
                while ($db->next_record()) {
                    echo '<option value="'.htmlspecialchars((int)$db->v('id'), ENT_COMPAT, 'ISO-8859-15').'"'
                        .($cpoSystem['standard_template']==(int)$db->v('id') ? ' selected' : '')
                        .'>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</option>';
                }
                echo '</select><br />';               
                ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Default page-template:'); ?></td>
            <td>
                <?php
                $query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
                        .'ORDER BY name';
                $db->query($query);
                $_pagetemplates = array();
                while ($db->next_record()) {
                    $_pagetemplates[$db->v('id')] = $db->v('name');
                }

                echo ___('Rubric page').': ';
                echo '<select name="cpoSystemNew[pagetemplate_index]" size="1">';
                echo '<option value="0"'
                    .($cpoSystem['pagetemplate_index']==0 ? ' selected' : '')
                    .'>'.___('Use header and footer files').'</option>';
                foreach ($_pagetemplates as $k=>$v) {
                    echo '<option value="'.htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15').'"'
                        .($cpoSystem['pagetemplate_index']==$k ? ' selected' : '')
                        .'>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</option>';
                }
                echo '</select><br />';

                echo ___('Article page').': ';
                echo '<select name="cpoSystemNew[pagetemplate_detail]" size="1">';
                echo '<option value="0"'
                    .($cpoSystem['pagetemplate_detail']==0 ? ' selected' : '')
                    .'>'.___('Use header and footer files').'</option>';
                foreach ($_pagetemplates as $k=>$v) {
                    echo '<option value="'.htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15').'"'
                        .($cpoSystem['pagetemplate_detail']==$k ? ' selected' : '')
                        .'>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</option>';
                }
                echo '</select><br />';
                ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Purge logfile:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[logfiledays]" value="<?php print(htmlspecialchars($cpoSystem['logfiledays'], ENT_COMPAT, 'ISO-8859-15')); ?>" size="36" maxlength="36">
                <?php echo help('system-systemsettings.html#system-systemsettings-project-deletelogfile'); ?>
                <?php echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> '.___('Logfile entries older than this number of days are automatically deleted. Use 0 to disable this feature.'); ?>
            </td>
        </tr><tr>
            <td>&nbsp;</td>
            <td>
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
            </td>
        </tr>
    </tbody>
    </table>

    <table class="colored" style="width: 100%;"><thead>
        <tr>
            <th colspan="2"><span><?php print(___('Workarounds')); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('"LOCK TABLES":'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input class="checkbox" type="checkbox" id="nolocktables" name="cpoSystemNew[nolocktables]" value="1" '.($cpoSystem['nolocktables'] ? 'checked' : '').'> <label for="nolocktables">'.___('disable').'</label>'.help('system-systemsettings.html#system-systemsettings-workarounds'); 
                echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                echo ___('Some providers don\'t allow the use of "LOCK TABLES" in their MySQL setup. If you experience database errors regarding this problem, you can disable the use of "LOCK TABLES" here. Please make sure that people don\'t edit e.g. the navigation structure simultaneously in this case.');
                ?>
            </td>
        </tr>
    </tbody>
    </table>

    <table class="colored" style="width: 100%;"><thead>
        <tr>
            <th colspan="2"><span><?php print(___('Developer tools')); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('"ERROR REPORTING":'); ?><br /><br />
            display_errors = <?php echo (ini_get('display_errors'))?'on':'off'; ?><br />
            log_errors = <?php echo (ini_get('log_errors'))?'on':'off'; ?></td>
            <td class="rightrow">
                <?php 
                function FriendlyErrorType($type) 
                { 
                    $return =""; 
                    if($type & E_ERROR) // 1 // 
                        $return.='| E_ERROR '; 
                    if($type & E_WARNING) // 2 // 
                        $return.='| E_WARNING '; 
                    if($type & E_PARSE) // 4 // 
                        $return.='| E_PARSE '; 
                    if($type & E_NOTICE) // 8 // 
                        $return.='| E_NOTICE '; 
                    if($type & E_CORE_ERROR) // 16 // 
                        $return.='| E_CORE_ERROR '; 
                    if($type & E_CORE_WARNING) // 32 // 
                        $return.='| E_CORE_WARNING '; 
                    if($type & E_COMPILE_ERROR) // 64 // 
                        $return.='| E_COMPILE_ERROR '; 
                    if($type & E_COMPILE_WARNING) // 128 // 
                        $return.='| E_COMPILE_WARNING '; 
                    if($type & E_USER_ERROR) // 256 // 
                        $return.='| E_USER_ERROR '; 
                    if($type & E_USER_WARNING) // 512 // 
                        $return.='| E_USER_WARNING '; 
                    if($type & E_USER_NOTICE) // 1024 // 
                        $return.='| E_USER_NOTICE '; 
                    if($type & E_STRICT) // 2048 // 
                        $return.='| E_STRICT '; 
                    if($type & E_RECOVERABLE_ERROR) // 4096 // 
                        $return.='| E_RECOVERABLE_ERROR '; 
                    if($type & E_DEPRECATED) // 8192 // 
                        $return.='| E_DEPRECATED '; 
                    if($type & E_USER_DEPRECATED) // 16384 // 
                        $return.='| E_USER_DEPRECATED '; 
                    //if($type & E_ALL) // 32767 // 
                    //    $return.='| E_ALL '; 
                    return substr($return,2); 
                } 
                $cArr = get_defined_constants(true)['Core'];
                asort($cArr);
                $type=(int)$cpoSystem['error_reporting'];
                foreach($cArr AS $cKey=>$cInt)  {
                    if (substr($cKey,0,2)=='E_' && $cKey!='E_ALL') {
                        if($type & $cInt) {
                            echo '<input class="err text" type="checkbox" value="'.$cInt.'" checked="checked" onChange="calcInt();" />';
                        } else {
                            echo '<input class="err text" type="checkbox" value="'.$cInt.'" onChange="calcInt();" />';
                        }
                        echo ' '. $cKey . ' (' . $cInt .')<br />';
                    }
                }
                
                echo '<input type="text" class="text" name="cpoSystemNew[error_reporting]" id="errInt" value="'.(int)$cpoSystem['error_reporting'].'" size="5" readonly />';
                echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                echo ___('Default settings by ConPresso:').' '.FriendlyErrorType(2039).' (2039)<br />';
                echo '<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                echo __('PHP error constants: <a href="https://www.php.net/manual/en/errorfunc.constants.php" target="_blank">https://www.php.net/manual/en/errorfunc.constants.php</a>');
                
                ?>
            </td>
        </tr><tr>
            <td><?php echo ___('Log missing translations:'); ?></td>
            <td>
                <select name="cpoSystemNew[missingTranslations]" size="1">
                    <option value="no" <?php   if ($cpoSystem['missingTranslations']=="no")   echo "selected"; ?>><?php echo ___('no'); ?></option>
                    <option value="text" <?php if ($cpoSystem['missingTranslations']=="text") echo "selected"; ?>><?php echo ___('textfile'); ?></option>
                    <option value="log" <?php  if ($cpoSystem['missingTranslations']=="log")  echo "selected"; ?>><?php echo ___('ConPresso logfile'); ?></option>
                </select>
            </td>
        </tr><tr>
            <td>&nbsp;</td>
            <td>
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
            </td>
        </tr>
    </tbody></table>

    <table class="colored" style="width: 100%;"><thead>
        <tr>
            <th colspan="2"><span><?php print(___('Editor-Settings')); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td><?php echo ___('Editor <body>-ID:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[bodyId]" value="<?php print(htmlspecialchars($cpoSystem['bodyId'], ENT_COMPAT, 'ISO-8859-15')); ?>" />
                <?php echo help(''); // TODO Add help for body ID?>
            </td>
        </tr><tr>
            <td><?php echo ___('CSS File (absolute URL):'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[CSSURL]" value="<?php print(htmlspecialchars($cpoSystem['CSSURL'], ENT_COMPAT, 'ISO-8859-15')); ?>" />
                <?php echo help('system-systemsettings.html#system-systemsettings-project-cssfile'); ?>
            </td>
        </tr><tr class="same">
            <td><?php echo ___('allowed CSS in the editor:'); ?></td>
            <td>
                <input type="text" class="text inputwidth" name="cpoSystemNew[editorCSS]" value="<?php print(htmlspecialchars($cpoSystem['editorCSS'], ENT_COMPAT, 'ISO-8859-15')); ?>" />
                <?php echo help('system-systemsettings.html#system-systemsettings-project-allowedcss'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Class selector on top:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input class="checkbox" type="checkbox" id="classSelectorOnTop" name="cpoSystemNew[classSelectorOnTop]" value="1" '.($cpoSystem['classSelectorOnTop'] ? 'checked' : '').'> <label for="classSelectorOnTop">'.___('enable').'</label>'.help('system-systemsettings.html#system-systemsettings-editor'); 
                //echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                //echo ___('Select checkbox if you want the class selector above the text area.');
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Show font selector:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input class="checkbox" type="checkbox" id="showFontSelectors" name="cpoSystemNew[showFontSelectors]" value="1" '.($cpoSystem['showFontSelectors'] ? 'checked' : '').'> <label for="showFontSelectors">'.___('enable').'</label>'.help('system-systemsettings.html#system-systemsettings-editor'); 
                //echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                //echo ___('Select checkbox if you want the font selectot to be shown.');
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Create relative links:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input class="checkbox" type="checkbox" id="relativeLinks" name="cpoSystemNew[relativeLinks]" value="1" '.($cpoSystem['relativeLinks'] ? 'checked' : '').'> <label for="relativeLinks">'.___('enable').'</label>'.help('system-systemsettings.html#system-systemsettings-editor'); 
                //echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                //echo ___('Select checkbox if you want links to be relative, e.g. if you don\'t use your content on other pages.');
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Show full toolbar:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input class="checkbox" type="checkbox" id="showFullToolbar" name="cpoSystemNew[showFullToolbar]" value="1" '.($cpoSystem['showFullToolbar'] ? 'checked' : '').'> <label for="showFullToolbar">'.___('enable').'</label>'.help('system-systemsettings.html#system-systemsettings-editor'); 
                //echo '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.___('Note').'" title="'.___('Note').'"> ';
                //echo ___('Select checkbox if you want links to be relative, e.g. if you don\'t use your content on other pages.');
                ?>
            </td>
        </tr><tr class="same">
            <td class="leftrow"><?php echo ___('Always full toolbar:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<select name="cpoSystemNew[roleToolbar]" size="1" >'; 
                    $roles = array(
                        99               => '- nobody -',
                        ROLE_ADMIN       => 'Admin',
                        ROLE_SUPERUSER   => 'Superuser',
                        ROLE_CHIEFEDITOR => 'Chief editor',
                        );
                    foreach ($roles as $k=>$v) {
                        echo '<option value="' . $k . '" ' . ($cpoSystem['roleToolbar']===(string)$k ? ' selected' : '') .
                             '>' . ___($v) . '</option>';
                    }
                echo '</select>'; 
                ?>
            </td>
        </tr><tr>
            <td>&nbsp;</td>
            <td>
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
            </td>
        </tr>
    </tbody></table>
    
    <table class="colored" style="width: 100%;"><thead>
        <tr>
            <th colspan="2"><span><?php print(___('Navigation settings')); ?></span></th>
        </tr>
    </thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('Startup navigation:'); ?><br /><br />
            </td>
            <td class="rightrow">
                <?php 
                //doActions($hdlr_navigation);
                //print_r($navigation);

                foreach($navigation AS $nKey=>$nVal)  {
                        if(isset($cpoSystem['startup'][$nKey]) && $cpoSystem['startup'][$nKey]=='1') {
                            echo '<input type="checkbox" name="cpoSystemNew[startup]['.$nKey.']" value="1" checked="checked" />';
                        } else {
                            echo '<input type="checkbox" name="cpoSystemNew[startup]['.$nKey.']" value="1" />';
                        }
                        echo ' '. __($nKey) . '<br />';
                }
                ?>
            </td>
        </tr><tr>
            <td>&nbsp;</td>
            <td>
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
            </td>
        </tr>
    </tbody></table>
    
    </form>




<script type="text/javascript">
function calcInt()  {  // error_reporting errechnen
    var errInt=0;
    var inputs=document.getElementsByTagName('input');
    for (var i=0; i<inputs.length; i++) {
        if (inputs[i].classList.contains('err') && inputs[i].checked) {
            errInt += parseFloat(inputs[i].value);
        };
    }
    document.getElementById('errInt').value = errInt;
}
</script>

<?php
require(CPO_BASEDIR.'_include/footer.php');