<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/common.inc.php');

// switch to true if you want the class selector on top
$classSelectorOnTop = (isset($cpoSystem['classSelectorOnTop']) && $cpoSystem['classSelectorOnTop']==1) ? true : false;

// switch to false if you want to disable font family and font size selectors
$showFontSelectors = (isset($cpoSystem['showFontSelectors']) && $cpoSystem['showFontSelectors']==1) ? true : false;

// if you want relative links, replace BASE_ABS with: '../'
$linkBase = (isset($cpoSystem['relativeLinks']) && $cpoSystem['relativeLinks']==1) ? '../' : BASE_ABS;

// full toolbar?
$showFullToolbar = (isset($cpoSystem['showFullToolbar']) && $cpoSystem['showFullToolbar']==1) ? true : false;
if (isset($cpoSystem['roleToolbar']) && $cpoSystem['roleToolbar']<=$_SESSION['SID_user']['admin']) $showFullToolbar = true;

$secIcons=array('', '&copysr;', '&copy;');
$secTexts=array(__('public rubric'), __('personalized rubric'), __('closed rubric'));

?>
<!-- vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4 nowrap: -->
<!-- this.edit = bse_conWin.document -->
<!-- this.cw = bse_conWin; -->
<html>
<head>
    <title><?php echo htmlspecialchars($CPO['product'].'-Editor', ENT_COMPAT, 'ISO-8859-15'); ?></title>
    <meta http-equiv="pragma"   content="no-cache">
    <meta name="robots" content="noindex, nofollow" />
    <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>">

    <style type="text/css">
    .settings {display: none; height: 100px; padding-top: 0.5em; padding-bottom: 0.5em;}
    input {margin: 0;}
    </style>
    <?php if (!$showFullToolbar)  {
        echo "<style>body.darker { background-position:0 -28px;}</style>";
        echo "\n";
    }
    ?>

    <script type="text/javascript">
    var storage = window.opener.document.getElementById('<?php echo htmlspecialchars($_REQUEST['saveto'], ENT_COMPAT, 'ISO-8859-15'); ?>').contentWindow;
    var deleteTagString = '<?php echo ___('delete tag'); ?>';
    var whichcolor = '';
    
    <?php 
    if (!empty($cpoSystem['CSSURL'])) {
        echo 'var CSSLink = \'<link rel="stylesheet" type="text/css" href="'.$cpoSystem['CSSURL'].'">\'';
    } else 
        echo 'var CSSLink = \'\';';
    echo "\n    ";
    if (!empty($cpoSystem['bodyId'])) {
        echo 'var bodyId = \'id="' . $cpoSystem['bodyId'] . '"\';';
    } else 
        echo 'var bodyId = \'\';';
    echo "\n";
    ?>

    /** display the toolbar buttons for a command
     */
    function addToolbarButton(bCommand, title)
    {
        switch (bCommand) {
        case '_help':
            <?php if ($cpoSystem['help']) { 
            $link = BASE_REL . '_manual/index.php?ref=articles-createarticle.html%23articles-createarticle-wysiwygeditor';
            ?>
            document.write('<a href="#" onClick="openDialog(\'<?php echo $link; ?>\', \'manual-window\', 600, 600, \'scrollbars=yes, resizable=yes\');">'); 
            document.write('<a href="<?php echo $link; ?>" target="manual_window">'); 
            document.write('<img src="images/btn_'+bCommand+'.gif" class="buttonRaised help" title="'+title+'" />');
            document.write('</a>');
            <?php } ?>
            break;
        case 'backcolor':
            document.write('<a href="#" onClick="doExecCommand(\''+bCommand+'\');">');
            document.write('<img src="images/btn_'+bCommand+'.gif" id="backcolor" class="buttonRaised" style="background: #ff0000;" title="<?php echo ___('set background color'); ?>" />');
            document.write('</a>');
            document.write('<a href="#" onClick="whichcolor = \'backcolor\'; openDialog(\'colorpicker.php?<?php echo SID; ?>\', \'\', 530, 285);">');
            document.write('<img src="images/btn_'+bCommand+'set.gif" class="buttonRaised" title="<?php echo ___('choose background color'); ?>" />');
            document.write('</a>');
            break;
        case 'forecolor':
            document.write('<a href="#" onClick="doExecCommand(\''+bCommand+'\');">');
            document.write('<img src="images/btn_'+bCommand+'.gif" id="forecolor" class="buttonRaised" style="background: #0000ff;" title="<?php echo ___('set foreground color'); ?>" />');
            document.write('</a>');
            document.write('<a href="#" onClick="whichcolor = \'forecolor\'; openDialog(\'colorpicker.php?<?php echo SID; ?>\', \'\', 530, 285);">');
            document.write('<img src="images/btn_'+bCommand+'set.gif" class="buttonRaised" title="<?php echo ___('choose foreground color'); ?>" />');
            document.write('</a>');
            break;
        case '_new':
            document.write('<a href="#" onClick="if (!confirm(\'<?php echo ___('Are you sure you want to create a clean document?'); ?>\')) return; doExecCommand(\''+bCommand+'\');">');
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        case 'insertimage':
            document.write('<a href="#" onClick="openDialog(\'imageinserter.php?<?php echo SID; ?>\', \'\', 400, 400);">');
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        case '_showtables':
            document.write('<a href="#" onClick="showTables();">');
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        default:
            document.write('<a href="#" onClick="doExecCommand(\''+bCommand+'\');">')
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        }
    }

    </script>
    <script src="<?php echo BASE_REL.'_editor/editor.js'; ?>" type="text/javascript"></script>
    <style>
    .buttonLowered   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonRaised    {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #357 1px solid; border-bottom: #357 1px solid; cursor: pointer;}
    .buttonRaised:active   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonFlattened {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer; }

    </style>
</head>
<body class="darker" style="margin: 0.5em;" onLoad="initializeEditor()">
<form>
<table style="width: 100%; height: 100%;"><tbody>
<tr><td>
    <script type="text/javascript">
    //document.write('<table style="padding:0; margin: 0;"><tbody><tr>');
    //document.write('<td>');
    document.write('<div style="float: left;">');
    //document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('_new', '<?php echo ___('new'); ?>');
    addToolbarButton('_save', '<?php echo ___('save'); ?>');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('cut', '<?php echo ___('cut'); ?>');
    addToolbarButton('copy', '<?php echo ___('copy'); ?>');
    addToolbarButton('paste', '<?php echo ___('paste'); ?>'); 
    addToolbarButton('selectall', '<?php echo ___('select all'); ?>');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    <?php if ($showFullToolbar) echo "addToolbarButton('indent', '". ___('indent') ."');"."\n"; ?>
    <?php if ($showFullToolbar) echo "addToolbarButton('outdent', '". ___('outdent') ."');"."\n"; ?>
    addToolbarButton('insertorderedlist', '<?php echo ___('insert ordered list'); ?>');
    addToolbarButton('insertunorderedlist', '<?php echo ___('insert unordered list'); ?>');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('createlink', '<?php echo ___('create link'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('_inserttable', '". ___('insert table') ."');"."\n"; ?>
    <?php if ($showFullToolbar) echo "addToolbarButton('_showtables', '". ___('show tables') ."');"."\n"; ?>
    addToolbarButton('insertimage', '<?php echo ___('insert image'); ?>');
    addToolbarButton('inserthorizontalrule', '<?php echo ___('insert horizontal rule'); ?>');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    //addToolbarButton('_switchmode', '<?php echo ___('switch mode'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('_switchmode', '". ___('switch mode') ."');"."\n"; ?>
    document.write('</div>');
    document.write('<div style="float: right;">');
    addToolbarButton('_help', '<?php echo ___('help'); ?>');
    //document.write('</td>');
    document.write('</div>');
    <?php if ($showFullToolbar) { ?>

    //document.write('</tr><tr>');

    //document.write('<td>');
    document.write('<br style="clear: both;" />');
    <?php } ?>
    document.write('<div style="float: left;">');
    //document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('undo', '<?php echo ___('undo'); ?>');
    addToolbarButton('redo', '<?php echo ___('redo'); ?>');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('justifyleft', '<?php echo ___('justify left'); ?>');
    addToolbarButton('justifycenter', '<?php echo ___('justify center'); ?>');
    addToolbarButton('justifyright', '<?php echo ___('justify right'); ?>');
    //addToolbarButton('justifyfull', '<?php echo ___('justify full'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('justifyfull', '". ___('justify full') ."');"."\n"; ?>
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');

    //document.write('<td>');
    <?php if ($showFullToolbar) { ?>
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('forecolor', '');
    addToolbarButton('backcolor', '');
    //document.write('</td>');
    //document.write('<td>&nbsp;</td>');
    document.write('</div>');
    <?php } ?>

    //document.write('<td colspan="3">');
    document.write('<div style="margin-left: 5px; float: left;">');
    document.write('<img src="images/btn_divider.gif" />');
    addToolbarButton('bold', '<?php echo ___('bold'); ?>');
    addToolbarButton('italic', '<?php echo ___('italic'); ?>');
    addToolbarButton('underline', '<?php echo ___('underline'); ?>');
    //addToolbarButton('strikethrough', '<?php echo ___('strikethrough'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('strikethrough', '". ___('strikethrough') ."');"."\n"; ?>
    //addToolbarButton('subscript', '<?php echo ___('subscript'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('subscript', '". ___('subscript') ."');"."\n"; ?>
    //addToolbarButton('superscript', '<?php echo ___('superscript'); ?>');
    <?php if ($showFullToolbar) echo "addToolbarButton('superscript', '". ___('superscript') ."');"."\n"; ?>
    addToolbarButton('removeformat', '<?php echo ___('remove format'); ?>');
    //document.write('</td>');
    document.write('</div>');

    //document.write('</tr></tbody></table>');
    </script>
    <div style="clear: both;">
    <select id="formatblock" onChange="doExecCommand('formatblock', this.value);">
        <option value="" selected><?php echo ___('Block format'); ?></option>
        <option value="<p>"><?php echo ___('Paragraph'); ?></option>
        <option value="<h1>"><?php echo ___('Headline 1'); ?></option>
        <option value="<h2>"><?php echo ___('Headline 2'); ?></option>
        <option value="<h3>"><?php echo ___('Headline 3'); ?></option>
        <option value="<h4>"><?php echo ___('Headline 4'); ?></option>
        <option value="<h5>"><?php echo ___('Headline 5'); ?></option>
        <option value="<h6>"><?php echo ___('Headline 6'); ?></option>
        <option value="<pre>"><?php echo ___('Preformatted'); ?></option>
        <option value="<address>"><?php echo ___('Address'); ?></option>
        <option value="<div>"><?php echo ___('Division'); ?></option>
    </select>

    <?php if ($showFontSelectors) { ?>
        <select id="fontsize" sCmd="fontsize" onChange="doExecCommand('fontsize', this.value);">
            <option value="" selected><?php echo ___('Font size'); ?></option>
            <option value="1">1</option>
            <option value="2">2</option>
            <option value="3">3</option>
            <option value="4">4</option>
            <option value="5">5</option>
            <option value="6">6</option>
            <option value="7">7</option>
        </select>

        <select id="fontname" sCmd="fontname" onChange="doExecCommand('fontname', this.value);";>
            <option value="" selected><?php echo ___('Font name'); ?></option>
            <option value="Times New Roman, Georgia, Times, serif">Times New Roman, Georgia, Times, serif</option>
            <option value="Arial, Helvetica, Geneva, Swiss, SunSans-Regular, sans-serif">Arial, Helvetica, Geneva, Swiss, SunSans-Regular, sans-serif</option>
            <option value="Courier New, Courier, Monaco, monospace">Courier New, Courier, Monaco, monospace</option>
            <option value="Verdana, Arial, Helvetica, Geneva, Swiss">Verdana, Arial, Helvetica, Geneva, Swiss</option>
        </select>
    <?php } ?>
    </div>
<!--  -->
<?php
$query = "SELECT snippet, name FROM ".CPO_SNIPPET." "
        ."WHERE rubric_id=".$_SESSION['SID_rubric_id']." OR rubric_id=-1 ORDER BY name";
$db = new DB;
$db->query($query);

if ($db->num_rows()>0) { 
    echo '<select id="snippets" onChange="encloseSelection(document.getElementById(\'snippets\').value); document.getElementById(\'snippets\').selectedIndex = 0;">';
    echo '<option value="" selected>' . ___('Snippets') . '</option>';
    echo '<option value="">--------------------------</option>';
    while($db->next_record()) {
        echo '<option value="'.htmlspecialchars($db->v('snippet'), ENT_COMPAT, 'ISO-8859-15').'">'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</option>';
    }
    echo '</select>';
}

$query = "SELECT id, datei, beschreibung FROM ".CPO_DATA." "
        ."WHERE (rubric_id='".$_SESSION['SID_rubric_id']."' OR rubric_id='-1') "
        ."AND format='1' ORDER BY datei";
$db->query($query);

if ($db->num_rows()>0) {
    echo ' <select id="files" onChange="encloseSelection(document.getElementById(\'files\').value); document.getElementById(\'files\').selectedIndex = 0;">';
    echo '<option value="" selected>' . ___('Files') . '</option>';
    echo '<option value="">--------------------------</option>';
    while($db->next_record()) {
        echo '<option value="';

        echo htmlspecialchars(
            '<A HREF="../_data/'.$db->v('datei').'" target="_blank">'
            .$db->v('beschreibung')
            .' ['.printHumanReadable(@filesize(CPO_BASEDIR.'_data/'.$db->v('datei'))).']</A>'
                , ENT_COMPAT, 'ISO-8859-15'
        );
        echo '">';

        if ($db->v('datei')!='') {
            $k_datei = $db->v('datei');
            $k_datei = substr($k_datei, 0, 50);
            echo htmlspecialchars($k_datei, ENT_COMPAT, 'ISO-8859-15');
        }
        
        if ($db->v('beschreibung')!='') {
            $k_beschreibung = $db->v("beschreibung")."##############################";
            $k_beschreibung = substr($k_beschreibung, 0, 30);
            $k_beschreibung = preg_replace ( "/#/", "&nbsp;", $k_beschreibung);

            echo ' - ' . $k_beschreibung;
        }

        echo '</option>';
    }
    echo '</select>';
}
?>
<script type="text/javascript">
    var allowedStyles = new Array();
    <?php 
    $a = explode(' ', $cpoSystem['editorCSS']);
    sort($a);
    foreach ($a as $v) {
        if (empty($v)) continue;
        echo 'allowedStyles.unshift(\''.$v.'\');';
    }
    ?>
</script>
<?php if ($classSelectorOnTop) { ?>
<div id="classText" style="display: none;"><?php echo ___('Class'); ?></div>
<div id="classSelectorOnTop" style="display: none;"><!-- --></div>
<input type="text" class="text" id="edit_universal_class" onChange="updateAttribute('class', this.value);" <?php
if (!empty($cpoSystem['editorCSS'])) echo 'style="display: none;"'; ?> />

<select id="edit_universal_class_select" onChange="updateAttribute('class', this.value);" <?php
if (empty($cpoSystem['editorCSS'])) echo 'style="display: none;"'; ?>>
</select>
<?php } ?>
<!--  -->
</td></tr>
<tr><td style="height: 100%;">
    <iframe id="bse_iFrame" style="width: 100%; height: 100%; margin: 0; border: 1px solid #000;" src="empty.html"></iframe>
</td></tr>
<tr><td>
    <fieldset style="margin: 0.5em 0;" ><legend><?php echo ___('Tag hierarchy').help('articles-createarticle.html#articles-createarticle-wysiwygeditor-taghierarchy'); ?></legend>
        <div id="tagHierarchy"><br /></div>
    </fieldset>
<tr><td style="height: 100px;">
    <fieldset id="edit_none" class="settings" style="display: block;">
        <legend>
            <?php 
            echo ___('Attributes').help('#articles-createarticle-wysiwygeditor-attributes');
            ?>
        </legend>
        <?php 
        echo ___('This area is reserved for the extended attributes of some tags. If you choose an element like an image or a table cell you will be able to edit its attributes here.');
        ?>
    </fieldset>

    <fieldset id="edit_" class="settings">
        <legend>
            <?php 
            echo ___('Attributes').help('#articles-createarticle-wysiwygeditor-attributes');
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <?php 
        echo ___('This area is reserved for the extended attributes of some tags. If you choose an element like an image or a table cell you will be able to edit its attributes here.');
        ?>
    </fieldset>

    <fieldset id="edit_universal" class="settings">
        <legend>
            <?php 
            echo ___('Universal attributes').' '; 
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to tag attributes').'</a>)'; 
            ?>
        </legend>
        <table style="width: 100%;"><tbody>
        <tr>
            <td style="width: 1%;">title:</td>
            <td style="width: 99%;"><input type="text" class="text inputwidth" id="edit_universal_title" onChange="updateAttribute('title', this.value);" /></td>
<?php if (!$classSelectorOnTop) { ?>
        </tr><tr>
            <td>class:</td>
            <td>
                <input type="text" class="text" id="edit_universal_class" onChange="updateAttribute('class', this.value);" <?php
                if (!empty($cpoSystem['editorCSS'])) echo 'style="display: none;"'; ?> />

                <select id="edit_universal_class_select" onChange="updateAttribute('class', this.value);" <?php
                if (empty($cpoSystem['editorCSS'])) echo 'style="display: none;"'; ?>>
                </select>
            </td>
<?php } ?>
        </tr><tr>
            <td>style:</td>
            <td><input type="text" class="text inputwidth" id="edit_universal_style" onChange="updateAttribute('style', this.value);" /></td>
        </tr>
        </tbody></table>
    </fieldset>

    <fieldset id="edit_a" class="settings">
        <legend>
            <?php 
            echo ___('A-Attributes').help(''); // helpme
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <table style="width: 95%;"><tbody>
        <tr>
            <td>href:</td>
            <td colspan="7"><input type="text" class="text inputwidth" id="edit_a_href" onChange="updateAttribute('href', this.value);" /></td>
            <td>&nbsp;</td>
        </tr><tr>
            <td><?php echo ___('Link to rubric:'); ?></td>
            <td colspan="7">
                <select id="edit_a_rubric" onChange="edit_a_href.value = this.value; updateAttribute('href', this.value); this.selectedIndex=0;">
                    <option value=""><?php echo ___('Generate a link to a rubric:'); ?></option>
                    <?php
                    $db = new DB;
                    $query = "SELECT id, name, directory, seclevel "
                            ."FROM ".CPO_RUBRIC." "
                            .'ORDER BY name';
                    $db->query($query);
                    while($db->next_record()) {
                        printf('<option value="%s" title="%s">%s</option>',
                            htmlspecialchars($linkBase . $db->v('directory').'/index.php?rubric='.urlencode($db->v('name')), ENT_COMPAT, 'ISO-8859-15'),
                            $secTexts[$db->v('seclevel')],
                            htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').' '.$secIcons[$db->v('seclevel')]
                        );
                    }
                    ?>
                </select>
            </td>
            <td>&nbsp;</td>
        </tr>
        <tr>
            <td>name:</td>
            <td><input type="text" class="text" id="edit_a_name" onChange="updateAttribute('name', this.value);" /></td>
            <td>&nbsp;</td>
            <td>target:</td>
            <td>
                <?php
                $targets = explode(' ', $cpoSystem['targets']);
                echo '<select id="edit_a_target" size="1" onChange="updateAttribute(\'target\', this.value);">';
                print('<option value="">' . ___('no target') . '</option><option value="">------</option>');
                foreach ($targets as $v) {
                    printf('<option value="%1$s">%1$s</option>',
                    htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15')
                    );
                }
                print('</select>');
                ?>
            </td>
            <td>&nbsp;</td>
            <td>title:</td>
            <td><input type="text" class="text" id="edit_a_title" onChange="updateAttribute('title', this.value);" /></td>
            <td>&nbsp;</td>
        </tr>
        </tbody></table>
    </fieldset>

<script type="text/javascript">
function imgSizeChanged(dimension, field)
{
    if (field.value.length==0 || isNaN(field.value))  {
        field.value = '';
        updateAttribute(dimension, field.value);
        return;
    }
    updateAttribute(dimension, field.value);
}
</script>
    <fieldset id="edit_img" class="settings">
        <legend>
            <?php 
            echo ___('IMG-Attributes').help(''); // helpme
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <!-- ismap, longdesc, name, usemap, align -->
        <table style="width: 100%;"><tbody>
        <tr>
            <td>src:</td>
            <td colspan="5" style="white-space: nowrap;">
                <input type="text" class="text" id="edit_img_src" onChange="updateAttribute('src', this.value);" style="width: 100%;" />
            </td>
            <td>
                <a href="#" style="vertical-align: bottom;" onClick="openDialog('imagepicker.php?<?php echo SID; ?>', '', 400, 400);"
                ><img src="images/btn_image.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 18px;" /></a>
            </td>
            <td>align:</td>
            <td colspan="5">
                <select class="select" id="edit_img_align" onChange="updateAttribute('align', this.value);">
                    <option value=""> </option>
                    <option value="top">top</option>
                    <option value="middle">middle</option>
                    <option value="bottom">bottom</option>
                    <option value=""> </option>
                    <option value="left">left</option>
                    <option value="right">right</option>
                </select>
            </td>
        </tr><tr>
            <td>alt:</td>
            <td colspan="5"><input type="text" class="text" id="edit_img_alt" onChange="updateAttribute('alt', this.value);" style="width: 100%" /></td>
            <td>&nbsp;</td>
            <td>hspace:</td>
            <td><input type="text" class="text" id="edit_img_hspace" onChange="updateAttribute('hspace', this.value);" size="8" /></td>
        </tr><tr>
            <td>width:</td>
            <td><input type="text" class="text" id="edit_img_width" onKeyUp="imgSizeChanged('width', this);" onChange="imgSizeChanged('width', this.value);" size="8" /></td>
            <td>height:</td>
            <td><input type="text" class="text" id="edit_img_height" onChange="updateAttribute('height', this.value);" size="8" /></td>
            <td>border:</td>
            <td><input type="text" class="text" id="edit_img_border" onChange="updateAttribute('border', this.value);" size="8" /></td>
            <td>&nbsp;</td>
            <td>vspace:</td>
            <td><input type="text" class="text" id="edit_img_vspace" onChange="updateAttribute('vspace', this.value);" size="8" /></td>
        </tr>
        </tbody></table>
    </fieldset>

    <fieldset id="edit_td" class="settings">
        <legend>
            <?php 
            echo ___('TD-Attributes').help(''); // helpme
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <!-- abbr, axis, char, charoff, colspan, headers, rowspan, scope -->
        <table style="width: 100%;"><tbody>
        <tr>
            <td>width:</td>
            <td><input type="text" class="text" id="edit_td_width" onChange="updateAttribute('width', this.value);" size="8" /></td>
            <td>&nbsp;</td>
            <td>align:</td>
            <td><select id="edit_td_align" onChange="updateAttribute('align', this.value);">
                <option value="">default</option>
                <option value="left">left</option>
                <option value="center">center</option>
                <option value="right">right</option>
                <option value="justify">justify</option>
            </select></td>
            <td>&nbsp;</td>
            <td>bgColor:</td>
            <td valign="top">
                <input type="text" class="text" id="edit_td_bgcolor" onChange="updateAttribute('bgcolor', this.value);" size="8" />
                <a href="#" onClick="whichcolor = 'edit_td_bgcolor'; openDialog('colorpicker.php?<?php echo SID; ?>', '', 530, 285);"
                ><img src="images/btn_color.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 18px;" alt="<?php echo ___('choose background color'); ?>" title="<?php echo ___('choose background color'); ?>" /></a>
            </td>
            <td>&nbsp;</td>
            <td>
                <a href="#" onClick="increaseColspan(settingsNode);"
                ><img src="images/btn_increase_colspan.gif" class="buttonRaised" alt="<?php echo ___('increase colspan'); ?>" title="<?php echo ___('increase colspan'); ?>" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="decreaseColspan(settingsNode);"
                ><img src="images/btn_decrease_colspan.gif" class="buttonRaised" alt="<?php echo ___('decrease colspan'); ?>" title="<?php echo ___('decrease colspan'); ?>" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="insertTableColumn(settingsNode, 0);"
                ><img src="images/btn_insert_col_0.gif" class="buttonRaised"     alt="<?php echo ___('insert col to the left'); ?>" title="<?php echo ___('insert col to the left'); ?>" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="insertTableColumn(settingsNode, 1);"
                ><img src="images/btn_insert_col_1.gif" class="buttonRaised"     alt="<?php echo ___('insert col to the right'); ?>" title="<?php echo ___('insert col to the right'); ?>" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="deleteTableColumn(settingsNode);"
                ><img src="images/btn_delete_col.gif" class="buttonRaised"       alt="<?php echo ___('delete col'); ?>" title="<?php echo ___('delete col'); ?>" style="vertical-align: bottom; width: 21px; height: 20px;" /></a>
            </td>
        </tr><tr>
            <td>height:</td>
            <td><input type="text" class="text" id="edit_td_height" onChange="updateAttribute('height', this.value);" size="8" /></td>
            <td>&nbsp;</td>
            <td>vAlign:</td>
            <td>
                <select id="edit_td_valign" onChange="updateAttribute('valign', this.value);" style="width: 100%;">
                    <option value="">Default</option>
                    <option value="top">Top</option>
                    <option value="middle">Middle</option>
                    <option value="baseline">Baseline</option>
                    <option value="bottom">Bottom</option>
                </select>
            </td>
            <td>&nbsp;</td>
            <td>NoWrap:</td>
            <td><input type="checkbox" id="edit_td_nowrap" onClick="updateAttribute('nowrap', this.checked);" /></td>
            <td>&nbsp;</td>
            <td>
                <a href="#" onClick="increaseRowspan(settingsNode);"
                ><img src="images/btn_increase_rowspan.gif" alt="<?php echo ___('increase rowspan'); ?>" title="<?php echo ___('increase rowspan'); ?>" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="decreaseRowspan(settingsNode);"
                ><img src="images/btn_decrease_rowspan.gif" alt="<?php echo ___('decrease rowspan'); ?>" title="<?php echo ___('decrease rowspan'); ?>" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="insertTableRow(settingsNode, 0);"
                ><img src="images/btn_insert_row_0.gif"     alt="<?php echo ___('add row above'); ?>" title="<?php echo ___('add row above'); ?>" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="insertTableRow(settingsNode, 1);"
                ><img src="images/btn_insert_row_1.gif"     alt="<?php echo ___('add row below'); ?>" title="<?php echo ___('add row below'); ?>" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="deleteTableRow(settingsNode);"
                ><img src="images/btn_delete_row.gif"       alt="<?php echo ___('delete row'); ?>" title="<?php echo ___('delete row'); ?>" class="buttonRaised" style="vertical-align: bottom;   width: 21px; height: 20px;" /></a>
            </td>
        </tr>
        </tbody></table>
    </fieldset>

    <fieldset id="edit_tr" class="settings">
        <legend>
            <?php 
            echo ___('TR-Attributes').help(''); // helpme
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <!-- char, charoff -->
        <table><tbody>
        <tr>
            <td>align:</td>
            <td><select id="edit_tr_align" onChange="updateAttribute('align', this.value);" style="width: 100%;">
                <option value="">Default</option>
                <option value="left">Left</option>
                <option value="center">Center</option>
                <option value="right">Right</option>
                <option value="justify">justify</option>
            </select></td>
            <td>&nbsp;</td>
            <td>bgColor:</td>
            <td>
                <input type="text" class="text" id="edit_tr_bgcolor" onChange="updateAttribute('bgcolor', this.value);" size="8" />
                <a href="#" onClick="whichcolor = 'edit_tr_bgcolor'; openDialog('colorpicker.php?<?php echo SID; ?>', '', 530, 285);"
                ><img src="images/btn_color.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 18px;" alt="<?php echo ___('choose background color'); ?>" title="<?php echo ___('choose background color'); ?>" /></a>
            </td>
            <td>&nbsp;</td>
            <td>
                <a href="#" onClick="insertTableRow(settingsNode, 0);"
                ><img src="images/btn_insert_row_0.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="insertTableRow(settingsNode, 1);"
                ><img src="images/btn_insert_row_1.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 20px;" /></a
                ><a href="#" onClick="deleteTableRow(settingsNode);"
                ><img src="images/btn_delete_row.gif" class="buttonRaised" style="vertical-align: bottom;   width: 21px; height: 20px;" /></a>
            </td>
        </tr><tr>
            <td>vAlign:</td>
            <td><select id="edit_tr_valign" onChange="updateAttribute('valign', this.value);">
                <option value="">Default</option>
                <option value="top">Top</option>
                <option value="middle">Middle</option>
                <option value="baseline">Baseline</option>
                <option value="bottom">Bottom</option>
            </select></td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
        </tr>
        </tbody></table>
    </fieldset>

    <fieldset id="edit_table" class="settings">
        <legend>
            <?php 
            echo ___('TABLE-Attributes').help(''); // helpme
            echo ' (<a href="#" onClick="updateSettingsView(!showUniversalSettings);">'.___('switch to universal attributes').'</a>)'; 
            ?>
        </legend>
        <!-- datafld, datasrc, dataformatas, frame, rules, summary -->
        <table><tbody>
        <tr>
            <td>align:</td>
            <td><select id="edit_table_align" onChange="updateAttribute('align', this.value);">
                <option value="">Default</option>
                <option value="left">Left</option>
                <option value="center">Center</option>
                <option value="right">Right</option>
            </select></td>
            <td>&nbsp;</td>
            <td>bgColor:</td>
            <td>
                <input type="text" class="text" id="edit_table_bgcolor" onChange="updateAttribute('bgcolor', this.value);" size="8" />
                <a href="#" onClick="whichcolor = 'edit_table_bgcolor'; openDialog('colorpicker.php?<?php echo SID; ?>', '', 530, 285);"
                ><img src="images/btn_color.gif" class="buttonRaised" style="vertical-align: bottom; width: 21px; height: 18px;" alt="<?php echo ___('choose background color'); ?>" title="<?php echo ___('choose background color'); ?>" /></a>
            </td>
            <td>&nbsp;</td>
            <td>cellpadding:</td>
            <td><input type="text" class="text" id="edit_table_cellpadding" onChange="updateAttribute('cellPadding', this.value);" size="8" /></td>
        </tr><tr>
            <td>border:</td>
            <td><input type="text" class="text" id="edit_table_border" onChange="updateAttribute('border', this.value);" size="8" style="width: 100%;" /></td>
            <td>&nbsp;</td>
            <td>width:</td>
            <td><input type="text" class="text" id="edit_table_width" onChange="updateAttribute('width', this.value);" size="8" style="width: 100%;" /></td>
            <td>&nbsp;</td>
            <td>cellspacing:</td>
            <td><input type="text" class="text" id="edit_table_cellspacing" onChange="updateAttribute('cellSpacing', this.value);" size="8" /></td>
        </tr>
        </tbody></table>
    </fieldset>
</td></tr></table>
</form>
</body>
</html>

<?php 
// Mod_inline *******************************************************************************************
if (array_key_exists('Inline',$activeModules)) include(INLINE_SNIPPETS);;
// Mod_inline *******************************************************************************************
?>
