<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/common.inc.php');


// *********************************************** CPO+ ******************************************************
// NEW: give all the standard and special placeholders by CPO and modules with parameters by an array!

$phSettings = array(
//  'Type'        => array('Caption', array('Parameter1', 'Parameter2'))
    'Image' => array('Image', array('file', 'alttext', 'width', 'height', 'description')), // PH Image 
    'File'  => array('File',  array('file', 'description', 'hrsize', 'size', 'starttag')), // PH File 
    'Text'  => array('Text',  array('strip_tags', 'nl2br')), // PH Text 
    'HTML'  => array('HTML',  array('strip_tags', 'htmlspecialchars')), // PH HTML 
    'URL'   => array('URL',   array('strip_tags', 'starttag', 'url', 'text', 'target')), // PH URL 
    );
foreach($hdlr_phSettings AS $module=>$add2phs)  {
    foreach($add2phs AS $addKey=>$addValArray)  {
        foreach($addValArray AS $addVal)  {
            if(!in_array($addVal, $phSettings[$addKey][1])) $phSettings[$addKey][1][]=$addVal;
        }
    }
}

$phSpecialSettings = array(
//  'Type: Name;'        => array('Caption', array('Parameter1', 'Parameter2'))
    'Value: Title;'      => array('Title', array('strip_tags', 'urlencode', 'htmlspecialchars')), // Value: title 
    'Value: Author;'     => array('Author', array('name', 'email', 'initials', 'urlencode')),   // Value: Author;
    'Value: Editor;'     => array('Editor', array('name', 'email', 'initials', 'urlencode')),   // Value: editor;
    'Value: pub_date;'   => array('Publication date', array('timestamp', 'format=')),  // Value: pub_date
    'Value: exp_date'    => array('Expiration date', array('timestamp', 'format=')),  // Value: exp_date
    'Value: chg_date;'   => array('Last changed date', array('timestamp', 'format=')),  // Value: chg_date
    'Value: articlenr'   => array('Article number', array()),  // Value: articlenr
    'Value: template;'   => array('Article-template number', array()),  // Value: template
    'Value: articleidx;' => array('Article index', array()),  // Value: articleidx
    'Value: rubric;'     => array('Rubric', array('id', 'directory', 'name', 'title', 'strip_tags', 'urlencode'))  // Value: rubric
     );
foreach($hdlr_phSpecialSettings AS $module=>$add2sphs)  {
    foreach($add2sphs AS $addKey=>$addValArray)  {
        if(!in_array($addKey, $phSpecialSettings)) $phSpecialSettings[$addKey]=$addValArray;
    }
}

$section = array();
foreach($hdlr_sections AS $module=>$add2sections)  {
    foreach($add2sections AS $addKey=>$addVal)  {
        if(!array_key_exists($addKey, $section)) $section[$addKey]=$addVal;
    }
}

// adding mod_gallery
//$phSpecialSettings['Slideshow: '] = array('Slideshow', array('Table', 'InPage', 'Show', 'Random', 'Picture1', 'PictureX')); // test new PH

// adding mod_form parms
//$phSpecialSettings['Form: '] = array('Form confirmation', array('confirm', 'delete', 'block', 'expire', 'step0', 'step1', 'step2', 'step3')); // test new PH

// create strings for the JS code
foreach($phSettings AS $phKey=>$phParms)  {
    $phKeys[]  = $phKey;
    $phNames[] = $phParms[0];
    $phOpts[]  = $phParms[1];
}
$phParmsVals = array();
foreach($phOpts AS $phKey=>$phParm) $phParmsVals[] = "['".implode("', '",$phParm)."']";
$phParmsString = implode(', ', $phParmsVals);

foreach($phSpecialSettings AS $phKey=>$phParms)  {
    $phSpecialKeys[]  = $phKey;
    $phSpecialNames[] = $phParms[0];
    $phSpecialParms[] = $phParms[1];
}
$phSpecialKeysString = "'" . implode("', '", $phSpecialKeys) . "'";

$phParmsVals = array();
foreach($phSpecialParms AS $phKey=>$phParms) $phParmVals[] = "['".implode("', '",$phParms)."']";
$phSpecialParmsString = implode(', ', $phParmVals);

// placeholders for ifSet/ifNotSet ($hdlr_phIfSets)
$phs = array(
    ' ', 
    '=== '.__('only ifSet/ifNotSet').' ===', 
    'loggedInUser', 
    'archive', 
    'UserGroupX',
    );
foreach($hdlr_phIfSets AS $module=>$add2phs)  {
    foreach($add2phs AS $addKey=>$addVal)  {
        if(!in_array($addVal, $phs)) $phs[]=$addVal;
    }
}


// *********************************************** CPO+ ******************************************************



?>
<html>
<head>
    <title><?php echo htmlspecialchars($CPO['product'].'-Editor', ENT_COMPAT, 'ISO-8859-15'); ?></title>
    <meta http-equiv="pragma"   content="no-cache">
    <meta name="robots" content="noindex, nofollow" />
    <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>">

    <script type="text/javascript">
    var storage = window.opener.document.getElementById('<?php echo $_REQUEST['saveto']; ?>').contentWindow;
    </script>
    <script src="<?php echo BASE_REL.'_editor/editor.js'; ?>" type="text/javascript"></script>
    <style>
    .buttonLowered   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonRaised    {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #357 1px solid; border-bottom: #357 1px solid; cursor: pointer;}
    .buttonRaised:active   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonFlattened {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer; }
    </style>
<script type="text/javascript"><!--
    var placeholder = window.opener.placeholder;
    // add extra entries
    <?php foreach($phs AS $ph) echo "if (!placeholder.includes('".$ph."')) placeholder.push('text', '".addslashes($ph)."');\n    "; ?>

    function populate_s_placeholder()
    {
        for (i=0; i<placeholder.length; i=i+2) {
            document.getElementById('s_placeholder').options[i/2] = new Option(placeholder[i+1], i);
        }
        return;
    }
    
    var phTypes = ['Image', 'File', 'Text', 'HTML', 'URL'];
    var phSpecial = [<?php echo $phSpecialKeysString; ?>];

    function changeSettings()
    {
        var a = [ <?php echo $phParmsString; ?> ];
        // remove entries from the list
        for (i=0; i<=document.getElementById('s_settings').length; i++) {
            document.getElementById('s_settings').options[0] = null
        }
        // add new entries
        for (i=0; i<a[document.getElementById('s_newType').value].length; i++) {
            document.getElementById('s_settings').options[i] = new Option(a[document.getElementById('s_newType').value][i], a[document.getElementById('s_newType').value][i]);
        }
    }

    function changeSpecialSettings()
    {
        var a = [ <?php echo $phSpecialParmsString; ?> ];
        // remove entries from the list
        while (document.getElementById('s_specialSettings').length > 0) {
            document.getElementById('s_specialSettings').options[0] = null
        }
        // add new entries
        for (i=0; i<a[document.getElementById('s_specialType').value].length; i++) {
            document.getElementById('s_specialSettings').options[i] = 
                new Option(a[document.getElementById('s_specialType').value][i], 
                           a[document.getElementById('s_specialType').value][i]);
        }
    }


    function newPlaceholder()
    {
        // alert(editArea.document.selection.createRange().parentElement().innerText)
        var phName = prompt('<?php print(___('Please enter a name for this placeholder:')); ?>', '');
        if (phName=='' || phName==null) {
            alert('<?php print(___('You have to enter a name for the new placeholder. No Placeholder created.')); ?>');
            return;
        }
        encloseSelection('<span style="color: #f00;">&lt;!-- '+phTypes[document.getElementById('s_newType').value]+': '+phName+'; --&gt;</span>');
        bse_conWin.focus();
        document.getElementById('s_placeholder').options[document.getElementById('s_placeholder').length] = new Option(phName, placeholder.length);
        placeholder.push(phTypes[document.getElementById('s_newType').value], phName);
    }
    function newSpecial()
    {
        encloseSelection('<span style="color: #f00;">&lt;!-- '+phSpecial[document.getElementById('s_specialType').value]+' --&gt;</span>');
        bse_conWin.focus();
    }
    function existingPlaceholder()
    {
        var counter = parseInt(document.getElementById('s_placeholder').value);
        encloseSelection('<span style="color: #f00;">&lt;!-- '+placeholder[counter]+': '+placeholder[counter+1]+'; --&gt;</span>');
        bse_conWin.focus();
    }
    function ifSet()
    {
        var counter = parseInt(document.getElementById('s_placeholder').value);
        encloseSelection(
            '<span style="color: #f00;">&lt;!-- '+document.getElementById('s_ifset').value+': '+placeholder[counter+1]+'; --&gt;</span>'+
            '<span style="color: #f00;">&lt;!-- /'+document.getElementById('s_ifset').value+' --&gt;</span>'
        );
        bse_conWin.focus();
    }

    function ifSection()
    {
        var sel = document.getElementById('s_sections');
        encloseSelection(
            '<span style="color: #f00;">&lt;!-- '+sel.value+' --&gt;</span>'+
            '<span style="color: #f00;">&lt;!-- /'+sel.options[sel.selectedIndex].text+' --&gt;</span>'
        );
        bse_conWin.focus();
    }


    function addSetting()
    {
        var phSetting = document.getElementById('s_settings').value;
        encloseSelection(phSetting+'; ');
        bse_conWin.focus();
    }
    function addSpecialSetting()
    {
        var phSetting = document.getElementById('s_specialSettings').value;
        encloseSelection(phSetting+'; ');
        bse_conWin.focus();
    }

    function addToolbarButton(bCommand, title)
    {
        switch (bCommand) {
        default:
            document.write('<a href="#" onClick="doExecCommand(\''+bCommand+'\');">');
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        }
    }

//--></script>
</head>
<body class="darker" style="margin: 1em;" onLoad="updateSView = false; initializeEditor(); populate_s_placeholder(); changeSpecialSettings(); changeSettings();">
<form>
<table style="width: 100%; height: 100%;"><tbody>
<tr><td>
    <script>
    document.write('<table style="padding:0; margin: 0;"><tbody><tr>');
    document.write('<td>');
    addToolbarButton('_new', '<?php echo ___('new'); ?>');
    document.write('<a href="#" onClick="window.opener.placeholder = placeholder; doExecCommand(\''+'_save'+'\');">');
    document.write('<img src="images/btn_'+'_save'+'.gif" bCmd="'+'_save'+'" class="buttonRaised" title="<?php echo ___('save');?>" />');
    document.write('</a>');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');

    document.write('<td>');
    addToolbarButton('cut', '<?php echo ___('cut'); ?>');
    addToolbarButton('copy', '<?php echo ___('copy'); ?>');
    addToolbarButton('paste', '<?php echo ___('paste'); ?>'); 
    addToolbarButton('selectall', '<?php echo ___('select all'); ?>');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');

    document.write('<td>');
    addToolbarButton('undo', '<?php echo ___('undo'); ?>');
    addToolbarButton('redo', '<?php echo ___('redo'); ?>');
    document.write('</td>');
    document.write('<td>');
    <?php if ($cpoSystem['help']) { 
    $link = BASE_REL . '_manual/index.php?ref=templates-workonarticletemplates.html%23templates-workonarticletemplates-workonarticletemplate-editor'; ?>
    document.write('<a href="#" onClick="openDialog(\'<?php echo $link; ?>\', \'manual-window\', 600, 600, \'scrollbars=yes, resizable=yes\');">'); 
    document.write('<a href="<?php echo $link; ?>" target="manual_window">'); 
    document.write('<img src="images/btn__help.gif" class="buttonRaised help" title="<?php echo __('help'); ?>" />');
    document.write('</a>');
    document.write('</span>');
    <?php } ?>
    document.write(' ');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');
    document.write('</tbody></table>');

    </script>


    <div>
        <?php print(___('Generic types:')); ?>
        <select id="s_newType" onChange="bse_conWin.focus(); changeSettings();">
            <?php $i=0; foreach($phSettings AS $phKey=>$phVal) echo '<option value="'.$i++.'">'.$phKey.'</option>'; ?>
        </select>
        <a href="javascript:newPlaceholder();"><?php print(___('create')); ?></a>

        <?php print(___('- possible options:')); ?>
        <select id="s_settings" onChange="bse_conWin.focus();">
            <option value="file"><?php print('file'); ?></option>
            <option value="alttext"><?php print('alttext'); ?></option>
            <option value="width"><?php print('width'); ?></option>
            <option value="height"><?php print('height'); ?></option>
            <option value="description"><?php print('description'); ?></option>
        </select>
        <a href="javascript:addSetting();"><?php echo ___('insert'); ?></a>

    </div>

    <div>
        <?php print(___('Special placeholders:')); ?>
        <select id="s_specialType" onChange="bse_conWin.focus(); changeSpecialSettings();">
            <?php foreach($phSpecialNames AS $phKey=>$phName) echo '<option value="'.$phKey.'">'.$phName.'</option>'; ?>
        </select>
        <a href="javascript:newSpecial();"><?php print(___('create')); ?></a>
        <?php print(___('- possible options:')); ?>
        <select id="s_specialSettings" onChange="bse_conWin.focus();">
            <option value="strip_tags"><?php print('strip_tags'); ?></option>
        </select>
        <a href="javascript:addSpecialSetting();"><?php echo ___('insert'); ?></a>
    </div>
    <div>
        <?php print(___('Existing placeholders:')); ?>
        <select id="s_placeholder" onChange="bse_conWin.focus();">
        </select>
        <a href="javascript:existingPlaceholder();"><?php echo ___('insert'); ?></a>

        <?php print(___('- conditional:')); ?>
        <select id="s_ifset" onChange="bse_conWin.focus();">
            <option value="ifSet"><?php print('ifSet'); ?></option>
            <option value="ifNotSet"><?php print('ifNotSet'); ?></option>
        </select>
        <a href="javascript:ifSet();"><?php echo ___('insert'); ?></a>
    </div>
    <div>
        <?php print(___('Sections:')); ?>
        <select id="s_sections" onChange="bse_conWin.focus();">
            <?php foreach($section AS $secKey=>$secVal) echo '<option value="'.$secVal.'">'.$secKey.'</option>'; ?>
        </select>
        <a href="javascript:ifSection();"><?php echo ___('insert'); ?></a>
    </div>
</td></tr>
<tr><td style="height: 100%;">
    <iframe id="bse_iFrame" style="width: 100%; height: 100%; margin: 0; border: 1px solid #000;" src="empty.html"></iframe>
</td></tr></table>
</form>
</body>
</html>
