<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4 nowrap: */
/* $nr Article number
 * $article_nr Article archive number
 * $freigabe release status
 * $_call file to call in links
 */

if (function_exists('mini_status')) return;

function mini_status($nr='', $article_nr='', $freigabe='', $_call='', $stufe4='')
{
    global $cpoSystem;

    if ($stufe4=='') $stufe4 = $_SESSION['SID_stufe4'];

    $query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
            ."WHERE article_nr='".addslashes($article_nr)."' "
            ."AND artikel_archiv='1'";
    DEBUG(1, 'Is there a newer article version?<br /><br />'.$query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query);
    $db_2->next_record();
    $newer_article = false;
    if ($db_2->v('COUNT(*)')>0) $newer_article = true;

    $pic_empty     = '<img src="'.SKIN_URL.'pic_empty.gif"  class="pic" alt="">';
    $pic_free      = '<img src="'.SKIN_URL.'pic_free.gif"   class="pic" alt="'.___('release article').'" title="'.___('release article').'" />';
    $pic_block     = '<img src="'.SKIN_URL.'pic_block.gif"  class="pic" alt="'.___('block article').'"   title="'.___('block article').'" />';
    $pic_reject    = '<img src="'.SKIN_URL.'pic_reject.gif" class="pic" alt="'.___('reject article').'"  title="'.___('reject article').'" />';
    $pic_free_s    = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_free.gif);  " alt="%1$s" title="%1$s" />';
    $pic_block_s   = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_block.gif); " alt="%1$s" title="%1$s" />';
    $pic_reject_s  = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_reject.gif);" alt="%1$s" title="%1$s" />';

    $c_free        = '<img src="'.SKIN_URL.'status_released.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('released').'" title="'.___('released').'">&nbsp;';
    $c_wait        = '<img src="'.SKIN_URL.'status_waiting.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('waiting').'"  title="'.___('waiting').'">&nbsp;';
    $c_block       = '<img src="'.SKIN_URL.'status_blocked.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('blocked').'"  title="'.___('blocked').'">&nbsp;';
    $c_reject      = '<img src="'.SKIN_URL.'status_rejected.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('rejected').'" title="'.___('rejected').'">&nbsp;';
    $c_reject_free = '<img src="'.SKIN_URL.'status_rejected-released.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('rejected, older article released').'" title="'.___('rejected, older article released').'">&nbsp;';
    $c_wait_free   = '<img src="'.SKIN_URL.'status_waiting-released.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('waiting, old article released').'" title="'.___('waiting, old article released').'">&nbsp;';


    if (strpos($_call, '?')) $_call .= '&amp;';
    else $_call .= '?';

    if (!$stufe4) {
        switch ($freigabe) {
        case STATE_RELEASED:
            print($c_free);
            $s = 'Status: released';
            printf($pic_free_s,   ___('You have no rights to change the status of an article.'));
            printf($pic_block_s,  ___('You have no rights to change the status of an article.'));
            printf($pic_reject_s, ___('You have no rights to change the status of an article.'));
            print('<br />'.__($s));
            break;
        
        case STATE_WAITING: 
            if ($newer_article) {
                print($c_wait_free);
                $s = 'Status: waiting<br />Old version: released';
            } else {
                print($c_wait);
                $s = 'Status: waiting';
            }
            printf($pic_free_s,   ___('You have no rights to change the status of an article.'));
            printf($pic_block_s,  ___('You have no rights to change the status of an article.'));
            printf($pic_reject_s, ___('You have no rights to change the status of an article.'));
            print('<br />'.__($s));
            break;
        
        case STATE_BLOCKED: 
            print($c_block);
            $s = 'Status: blocked';
            printf($pic_free_s,   ___('You have no rights to change the status of an article.'));
            printf($pic_block_s,  ___('You have no rights to change the status of an article.'));
            printf($pic_reject_s, ___('You have no rights to change the status of an article.'));
            print('<br />'.__($s));
            break;
        
        case STATE_REJECTED:
            if ($newer_article) {
                print($c_reject_free);
                $s = 'Status: rejected<br />Old version: released';
            } else {
                print($c_reject);
                $s = 'Status: rejected';
            }
            printf($pic_free_s,   ___('You have no rights to change the status of an article.'));
            printf($pic_block_s,  ___('You have no rights to change the status of an article.'));
            printf($pic_reject_s, ___('You have no rights to change the status of an article.'));
            print('<br />'.__($s));
            break;
        }
    } else {
        // user is allowed to change the status
        switch ($freigabe) {
        case STATE_RELEASED:
            print($c_free);
            $s = 'Status: released';
            if ($_call!='?') {
                printf($pic_free_s, ___('The article is already released.'));
                print('<a href="'.BASE_REL.$_call.'status='.STATE_BLOCKED.'&nr='.$nr.'">');
                print($pic_block.'</a>');
                if ($cpoSystem['release']) {
                    echo '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
                    print($pic_reject.'</a>');
                }
            }
            print('<br />'.__($s));
            break;
        
        case STATE_WAITING: 
            if ($newer_article) {
                print($c_wait_free);
                $s = 'Status: waiting<br />Old version: released';
            } else {
                print($c_wait);
                $s = 'Status: waiting';
            }
            if ($_call!='?') {
                echo '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
                print($pic_free.'</a>');
                printf($pic_block_s, ___('The article is in state waiting and can not be blocked.'));
                echo '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
                print($pic_reject.'</a>');
            }
            print('<br />'.__($s));
            break;
        
        case STATE_BLOCKED: 
            print($c_block);
            $s = 'Status: blocked';
            if ($_call!='?') {
                echo '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
                print($pic_free.'</a>');
                printf($pic_block_s, ___('The article is already blocked.'));
                if ($cpoSystem['release']) {
                    echo '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
                    print($pic_reject.'</a>');
                }
            }
            print('<br />'.__($s));
            break;
        
        case STATE_REJECTED:
            if ($newer_article) {
                print($c_reject_free);
                $s = 'Status: rejected<br />Old version: released';
            } else {
                print($c_reject);
                $s = 'Status: rejected';
            }
            if ($_call!='?') {
                echo '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
                print($pic_free.'</a>');
                printf($pic_block_s, ___('The article was rejected and can not be blocked.'));
                printf($pic_reject_s, ___('The article already was rejected.'));
            }
            print('<br />'.__($s));
            break;
        }
    }
}
?>
