<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

global $key, $content, $_type, $_name, $db_autor, $db_email, $db_initial, $db_nr, $db_template, $db_idx, $db_pub_datum, $db_verfallsdatum, $db_titel, $db_content, $db_changer, $db_rubric_id, $db_last_modify;

// which value is requested?
switch (true) {
case stristr(strtolower($key), 'editor'):
    $db_content->query('SELECT name, initial, email FROM '.CPO_USER." WHERE user='".addslashes($db_changer)."' ");
    if ($db_content->next_record()) {
        $content[$key] = array(
            'type'          => $_type,
            'name'          => $_name,
            'editorname'    => $db_content->v('name'),
            'editoremail'   => $db_content->v('email'),
            'editorinitials'=> $db_content->v('initial')
        );
    }
    break;
case stristr(strtolower($key), 'author'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'authorname'    =>$db_autor,
        'authoremail'   =>$db_email,
        'authorinitials'=>$db_initial
    );
    break;
case stristr(strtolower($key), 'articlenr'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'articlenr'     =>$db_nr
    );
    break;
case stristr(strtolower($key), 'template'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'template'      =>$db_template
    );
    break;
case stristr(strtolower($key), 'articleidx'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'articleidx'    =>$db_idx
    );
    break;
case stristr(strtolower($key), 'pub_date'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'pub_date'      =>$db_pub_datum
    );
    break;
case stristr(strtolower($key), 'exp_date') && ($db_verfallsdatum!='2036-01-01 00:00:00'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'exp_date'      =>$db_verfallsdatum
    );
    break;
case stristr(strtolower($key), 'chg_date'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'chg_date'      =>$db_last_modify
    );
    break;

/* commentary is an internal field that should not be used in templates...
case stristr(strtolower($key), 'commentary'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'commentary'    =>$db_commentary
    );
    break;
/* */

case stristr(strtolower($key), 'title'):
    $content[$key] = array(
        'type'          =>$_type,
        'name'          =>$_name,
        'title'         =>$db_titel
    );
    break;

case stristr(strtolower($key), 'rubric'):
    $db_content->query('SELECT directory, name, settings '
        .'FROM '.CPO_RUBRIC.' '
        .'WHERE id='.(int)$db_rubric_id
    ); 

    if (!$db_content->next_record()) break;

    $_settings = unserialize($db_content->v('settings'));
    if (!is_array($_settings)) break; // FIXME add better settings loading and check

    $content[$key] = array(
        'type'   => $_type,
        'name'   => $_name,
        'rubricid'        => $db_rubric_id,
        'rubricname'      => $db_content->v('name'), 
        'rubricdirectory' => $db_content->v('directory'), 
        'rubrictitle'     => $_settings['title'] 
    );
    break;
}
?>
