<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

global $parameters, $replacement, $content, $key;

if (array_key_exists('file', $parameters)) {
    $replacement = $content[$key]['file'];
    return;
}
if (array_key_exists('description', $parameters)) {
    $replacement = $content[$key]['description'];
    
    if (!array_key_exists('htmlspecialchars', $parameters)
        || in_array(strtolower($parameters['htmlspecialchars']), array('1', 'true', 'on'))) {
        $replacement = htmlspecialchars($replacement, ENT_COMPAT, 'ISO-8859-15');
    }
    return;
}
if (array_key_exists('hrsize', $parameters)) {
    $replacement = printHumanReadable($content[$key]['size']);
    return;
}
if (array_key_exists('size', $parameters)) {
    $replacement = $content[$key]['size'];
    return;
}
if (array_key_exists('starttag', $parameters)) {
    $replacement = sprintf('<a href="../_data/%s">', 
        $content[$key]['file']
    );
    return;
}
$replacement = sprintf('<a href="../_data/%s">%s [%s]</a>', 
    $content[$key]['file'],
    htmlspecialchars($content[$key]['file'], ENT_COMPAT, 'ISO-8859-15'),
    printHumanReadable($content[$key]['size'])
);