<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// some defaults
initVar($cpoRubricSettings['disableRubric'], false);
initVar($cpoRubricSettings['sorting'], 'pub_datum DESC');
initVar($cpoRubricSettings['noOfArticles'], 10);
initVar($cpoRubricSettings['noArticlesFound'], __('No articles found.'));
initVar($cpoRubricSettings['pager_showresults'], '');
initVar($cpoRubricSettings['showArchive'], __('Archive'));


// get article by title
if (!isset($_REQUEST['nr']) && isset($_REQUEST['title'])) { 
   $query = "SELECT article_nr " 
         ."FROM ".CPO_NEWS." " 
         ."WHERE titel='".$_REQUEST['title']."' " 
         ."AND rubric_id=".$cpoRubricId." AND artikel_archiv=0"; 
   DEBUG(2, $query, __FILE__, __LINE__);    
   $db = new DB; 
   $db->query($query); 
   $db->next_record(); 
   $_REQUEST['nr'] = $db->v('article_nr'); 
   $_GET['nr'] = $db->v('article_nr'); 
} 

// if the rubric is disabled, print message and return
if ($cpoRubricSettings['disableRubric'] && 
    !($_SESSION['SID_user']['admin']>ROLE_MEMBER && isset($_REQUEST['preview']))) { // don't show if preview is chosen OR
    //!($_SESSION['SID_user']['admin']>ROLE_MEMBER)) { // don't show if an editor is logged in
    $_t = $cpoRubricSettings['disableRubricText'];
    if ($pagetype=='js') $_t = "document.write('".$_t."');";

    echo $_t;
    return;
}

if ($cpoSystem['statistics']) {
    $datum = date('Y-m-d H:i:s');
    $query = 'UPDATE '.CPO_STATISTICS.' SET '
            .'index_site = index_site+1, '
            ."last_hit = '".$datum."', "
            ."c_time = '".$datum."' "
            .'WHERE rubric_id='.(int)$cpoRubric['id'];
    $db = new DB;
    $db->query($query);

    // if there was no entry updated, add an entry with a starting value of 1
    if ($db->affected_rows()==0) { 
        $query = 'INSERT INTO '.CPO_STATISTICS.' '
                .'(rubric_id, index_site, detail_site, archive_site, last_hit, c_time) '
                .'VALUES ('.(int)$cpoRubric['id'].", 1, 0, 0, '".$datum."', '".$datum."')";
        $db->query($query);
    }
} 

// set starting article if not defined already
if (!isset($_REQUEST['pos']) || $_REQUEST['pos']<0) $_REQUEST['pos'] = 0;

$where = "FROM ".CPO_NEWS." "
        ."WHERE ";

$articlestates = $cpoSystem['release'] 
    ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' ' 
    : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' ';
$now = time();

// PREVIEW
if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>ROLE_MEMBER && isset($_REQUEST['preview'])) {
    $articlestates = 'artikel_archiv<1 AND freigabe<='.STATE_WAITING.' ';
    $now = strtotime($_REQUEST['preview']); 
}


$where .= $articlestates
         ."AND pub_datum<='".date('Y-m-d H:i:s', $now)."' "
         ."AND verfallsdatum>='".date('Y-m-d H:i:s', $now)."' "
         .'AND rubric_id='.(int)$cpoRubric['id'].' ';

// if this is a personalized rubric, set the string that only fetches
// articles corresponding to the group of the logged in user 
$auth_string = '1';
if ($cpoRubric['seclevel']>SECLEVEL_PUBLIC) {
    $auth_string = "auth=''";
    if ($_SESSION['SID_user']['usergroups_id']>0) {
        $auth_string .= " OR auth LIKE '%#".(int)$_SESSION['SID_user']['usergroups_id']."#%'";  
    }
}
$where .= 'AND ('.$auth_string.') ';

// figure out the position of the requested article 
if ($pagetype=='index' && isset($_REQUEST['nr'])) {
    $db = new DB;
    $db->query('SELECT nr '.$where.' '
              .'ORDER BY '.$cpoRubricSettings['sorting']);
    $i = 0;
    while ($db->next_record()) {
        if ($db->v('nr')==$_REQUEST['nr']) {
            $_REQUEST['pos'] = floor($i/$cpoRubricSettings['noOfArticles'])*$cpoRubricSettings['noOfArticles'];
            break;
        }
        $i++;
    }
}

$query_count = 'SELECT COUNT(*) '.$where;
$query       = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify '
              .$where
              .'ORDER BY '.$cpoRubricSettings['sorting'].' '
              .'LIMIT '.(int)$_REQUEST['pos'].', '.(int)$cpoRubricSettings['noOfArticles'];
$db = new DB;
$db->query($query_count);
$db->next_record();
$max_anzahl = $db->v('COUNT(*)');

$db->query($query);
$anzahl = $db->num_rows();

// no articles found
if ($anzahl<=0) {
    if ($pagetype!='js') {
        echo $cpoRubricSettings['noArticlesFound'];
    } else {
        // if output is for javascript, clean "up"
        $output = preg_replace("/(\015\012)|(\015)|(\012)/", '', $cpoRubricSettings['noArticlesFound']);
        $output = str_replace("'", "\\'", $cpoRubricSettings['noArticlesFound']);
        printf("document.write('%s');\n", $cpoRubricSettings['noArticlesFound']);
    }

    // load next_index.php (possible archive)
    if (!isset($_REQUEST['preview']) && $pagetype=='index') 
        require(CPO_BASEDIR.'_include/next_index.php');
    return;
}

$GLOBALS['lastUpdated'] = 0;
$articleSeparator = '';
while($db->next_record()) {
    echo $articleSeparator;

    $db_template      = $db->v('templates_id');
    $db_nr            = $db->v('nr');
    $db_idx           = $db->v('idx');
    $db_email         = $db->v('email');
    $db_autor         = $db->v('autor');
    $db_changer       = $db->v('changer');
    $db_pub_datum     = $db->v('pub_datum');
    $db_verfallsdatum = $db->v('verfallsdatum');
    $db_commentary    = $db->v('commentary');
    $db_titel         = $db->v('titel');
    $db_initial       = $db->v('initial');
    $db_freigabe      = $db->v('freigabe');
    $db_rubric_id     = $db->v('rubric_id');
    $db_last_modify   = $db->v('last_modify');
    if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
        $GLOBALS['lastUpdated'] = strtotime($db_last_modify);
    }
    require(CPO_BASEDIR.'_include/select_template.php');

    $articleSeparator = $cpoRubricSettings['articleSeparator'];
}

if (!isset($_REQUEST['preview']) && $pagetype=='index') require(CPO_BASEDIR.'_include/next_index.php');
if (isset($_REQUEST['preview']) && $pagetype=='index') {
    next_page(
        $_REQUEST['pos'], 
        $max_anzahl, 
        $cpoRubricSettings['noOfArticles'], 
        $cpoRubricSettings['pager_showresults'], 
        'rubric='.(int)$cpoRubric['id'].'&amp;preview='.urlencode($_REQUEST['preview']),
        '', 
        $tl
    );
}
