<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// define some vars
initVar($_REQUEST['settings']['externalURL'],'');
initVar($_REQUEST['settings']['externalURLTarget'],'');


printPageHeader(
    __('Edit navigation element'),
    sprintf(___('In this view you can edit the settings of the navigation element %s.'), 
        '<em>'.htmlspecialchars($_REQUEST['caption'], ENT_COMPAT, 'ISO-8859-15').'</em>'),
    'rubrics-workonnavigation.html#rubrics-workonnavigation-editelement'
);
include(CPO_BASEDIR.'_include/message.php');

printf('<form method="post" action="%s">', htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'));
printf('<input type="hidden" value="%s" name="action[]" />', 'navigation_edit_save');
printf('<input type="hidden" value="%s" name="id" />', htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15'));
printf('<input type="hidden" value="%s" name="create" />', htmlspecialchars($_REQUEST['create'], ENT_COMPAT, 'ISO-8859-15'));

print('<table class="colored" style="width: 100%"><thead><tr>');
printf('<th colspan="2"><span>%s</span></th>', ___('Navigational element settings').help('rubrics-workonnavigation.html#rubrics-workonnavigation-editelement'));
print('</tr></thead><tbody>');

printf('<tr><td class="leftrow">%s</td>', ___('Caption:'));
print('<td class="rightrow">');
printf('<input type="text" value="%s" name="caption" class="text inputwidth" maxlength="255" />%s', 
    htmlspecialchars($_REQUEST['caption'], ENT_COMPAT, 'ISO-8859-15'), 
    help('rubrics-workonnavigation.html#rubrics-workonnavigation-editelement-description')
);
print('</td></tr>');

printf('<tr><td class="leftrow">%s</td>', ___('Rubric assignment:'));
print('<td class="rightrow">');
print('<select class="select inputwidth" name="rubric_id" size="1">');
    printf('<option value="%d" %s>%s</option>',
        0,
        $_REQUEST['rubric_id']==0? 'selected' : '',
        ___('[None]')
    );

    $query = 'SELECT id, name FROM '.CPO_RUBRIC.' ORDER BY name';
    $db = new DB; 
    $db->query($query);
    $rubrics = array();
    while ($db->next_record()) {
        printf('<option value="%d" %s>%s</option>',
            htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
            $db->v('id')==$_REQUEST['rubric_id'] ? 'selected' : '',
            htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15')
        );
    }
print('</select>'.help('rubrics-workonnavigation.html#rubrics-workonnavigation-editelement-rubric'));
print('</td></tr>');

printf('<tr><td class="leftrow">%s</td>', ___('external URL:'));
print('<td class="rightrow">');
printf('<input type="text" class="text inputwidth" name="settings[externalURL]" value="%s" maxlength="255" />%s',
    htmlspecialchars($_REQUEST['settings']['externalURL'], ENT_COMPAT, 'ISO-8859-15'),
    help('rubrics-workonnavigation.html#rubrics-workonnavigation-editelement-externurl')
);
print('</td></tr>');

printf('<tr class="same"><td class="leftrow">%s</td>', ___('external URL target:'));
print('<td class="rightrow">');
printf('<input type="text" class="text inputwidth" name="settings[externalURLTarget]" value="%s" maxlength="255" />%s', 
    htmlspecialchars($_REQUEST['settings']['externalURLTarget'], ENT_COMPAT, 'ISO-8859-15'),
    help('rubrics-workonnavigation.html#rubrics-workonnavigation-editelement-externtarget')
);
print('</td></tr>');

print('<tr><td class="leftrow">&nbsp;</td>');
print('<td class="rightrow">');
printf('<input type="submit" class="button" value="%s" /></td></tr>', __('save'));
print('</tbody></table>');
print('</form>');